define(function (require) {
  var App = require('app');

  return Backbone.Model.extend({

    defaults: {
      medicationName: '',
      medicationType: '',
      currentlyTaking: true,
      strength: '',
      frequencyTaken: '',
      instructions: '',
      reasonForTaking: '',
      refillsRemaining: '',
      rxNumber: '',
      prescriber: '',
      pharmacyName: '',
      pharmacyPhoneNumber: '',
      lastRefillDate: '',
      startDate: '',
      stopDate: '',
      unwantedSideEffects: false,
      sideEffectsComment: '',
      comments: '',
      deleteMedication: false
    },
    initialize: function (opts) {
      this.options = opts || {};
    },
    url: function () {
      return App.Resources.get('vamom-medications-detail').href + '?veteranId=' + App.Resources.user.id;
    }
  });
});
