define(function (require) {
  var App = require('app');

  return Backbone.Marionette.ItemView.extend({
    tagName: 'div',
    className: 'form-field',
    initialize: function (opts) {
      this.options = opts || {};
    },
    getTemplate: function () {
      var template = null;
      switch (this.model.get('type')) {
        case 'text':
          template = require('text!../html/fields/textField.html');
          return _.template(template);
        case 'date':
          template = require('text!../html/fields/dateField.html');
          return _.template(template);
        case 'switch':
          template = require('text!../html/fields/switchField.html');
          return _.template(template);
        case 'select':
          template = require('text!../html/fields/selectField.html');
          return _.template(template);
        case 'obContact':
          template = require('text!../html/fields/obContactField.html');
          return _.template(template);
        case 'bloodPressure':
          template = require('text!../html/fields/bloodPressureField.html');
          return _.template(template);
        case 'textarea':
          template = require('text!../html/fields/textareaField.html');
          return _.template(template);
        case 'checkbox':
          template = require('text!../html/fields/checkboxField.html');
          return _.template(template);
        case 'age':
          template = require('text!../html/fields/ageField.html');
          return _.template(template);
        case 'efw':
          template = require('text!../html/fields/efwField.html');
          return _.template(template);
      }
    },
    onShow: function () {
      if (this.model.get('disabled')) {
        this.$el.addClass('disabled');
      }
      if (this.model.get('type') === 'date') {
        this.$el.find('.datepicker').datepicker({
          todayBtn: 'linked',
          todayHighlight: true,
          autoclose: true
        }).on('changeDate', function (e) {
          App.Dateman.changeDate(e);
        });
      }
      //this is for grouping together RhType and Antibody dropdown
      if (this.model.get('id') === 'rhType') {
        this.$el.css('border-bottom', '0');
      }
    }

  });
});
