define(function (require) {
  var App = require('app');
  var template = require('text!../html/exportPregTrackerView.html');

  return Backbone.Marionette.ItemView.extend({
    id: '',
    tagName: 'div',
    className: 'exportData container',
    template: _.template(template),
    header: {
      outer: 'Export'
    },
    events: {
      'click #create-pdf': 'clickAndGetPdf'
    },

    initialize: function (models) {
      var isEmpty = true;
      for (var k in models[0].attributes) {
        if (models[0].attributes[k] !== '') {
          isEmpty = false;
          break;
        }
      }

      models[0].set('isEmpty', isEmpty);

      if (models[0].get('profile')) {
        var date = models[0].get('profile').edd;

        var profile = models[0].get('profile');
        profile.weeks = App.templateHelpers.getPregnancyWeekNumber(date);
        console.log(profile.weeks);
        models[0].set('profile', profile);
      }
      this.model = models[0];

      this.model.on('change', this.render, this);
    },

    onShow: function () {

      //$('.fieldname').attr('aria-hidden', 'true');
    },

    clickAndGetPdf: function (e) {
      e.preventDefault();
      var url = App.Resources.get('vamom-export-report').href + '?veteranId=' + App.Resources.user.id;
      window.open(url);
    }

  });
});
