define(function (require) {
  var App = require('app');
  var loggedOutTemplate = require('text!../html/homeView.html');
  var firstEntryTemplate = require('text!../html/homeViewFirstEntry.html');
  var loggedInTemplate = require('text!../html/homeViewLoggedIn.html');

  return Backbone.Marionette.ItemView.extend({
    id: '',
    tagName: 'div',
    className: 'container',
    route: 'index',
    events: {
      'click #login': 'logon'
    },
    getTemplate: function () {
      if (App.Resources.isLoggedIn()) {
        if (App.models.profile.isNew()) {
          this.$el.addClass('home');
          return _.template(firstEntryTemplate);
        } else {
          this.$el.addClass('logged-in-home');
          return _.template(loggedInTemplate);
        }
      } else {
        this.$el.addClass('home');
        return  _.template(loggedOutTemplate);
      }
    },
    initialize: function () {
      App.models.profile.fetch({async: false});
      this.model = App.models.profile;
      this.on('show:after', function () {
        $('#content .container').css('margin-top', '75px');
      });
    },
    logon: function (e) {
      e.preventDefault();
      App.Resources.login();
    },
    onShow: function () {
      this.listenTo(App.vent, 'labs:refresh', this.updateLabsDue);
      App.models.profile.fetch({
        global: false,
        success: function () {
          App.vent.trigger('labs:refresh');
        }
      });
    },
    updateLabsDue: function () {
      if (parseInt(App.models.profile.get('labDueItems')) === 1) {
        $('#labs-due').text(App.models.profile.get('labDueItems') + ' Item Due');
      } else {
        $('#labs-due').text(App.models.profile.get('labDueItems') + ' Items Due');
      }
      var $pregTracker = $('#preg-tracker');
      $pregTracker.attr('aria-label', $pregTracker.text());
    }
  });
});
