define(function (require) {
  var App = require('app');
  var template = require('text!../html/popup/deleteView.html');

  return Backbone.Marionette.ItemView.extend({
    id: 'modalBox',
    tagName: 'div',
    events: {
      'click #delete-btn': 'deleteEventTrigger',
      'click .cancel-delete': 'cancelEventTrigger'
    },
    template: _.template(template),
    initialize: function (opts) {
      this.name = opts.name;
      this.optionalText = opts.optText;
    },
    serializeData: function () {
      return {
        name: this.name,
        optionalText: this.optionalText
      };
    },
    deleteEventTrigger: function () {
      App.vent.trigger('item:delete');
    },
    cancelEventTrigger: function () {
      App.vent.trigger('item:canceldelete');
    }

  });
});
