define(function (require) {
  var App = require('app');

  var template = require('text!../html/popup/popUpView.html');

  return Backbone.Marionette.Layout.extend({
    template: _.template(template),
    popupContent : null,
    idNum: 0,
    regions: {
    },
    initialize: function (args) {
      this.popupContent = args.view;
      this.idNum = args.idNum || 0;
    },
    serializeData: function () {
      return {
        id : this.idNum
      };
    },
    onRender: function () {
      var popupContentId = '#popup-' + this.idNum;

      this.addRegion('content', popupContentId);

      this.content.show(this.popupContent);

    },
    onShow : function () {
      var $popup = $(App.popupRegion.$el).find('.modal');
      var that = this;
      var $overlay = $('.modal-backdrop');

      if ($popup.length > 0) {
        $popup.on('shown.bs.modal', function () {
          var idx = ($('.modal:visible').length) - 1; // raise backdrop after animation.
          if (idx === 0) {
            $('.modal').attr('id', 'oneModal');
            $('.modal-backdrop').attr('id', 'oneOverlay');
          }
          if ($('.modal').attr('id') === 'oneModal' && idx === 1) {
            $('#oneModal').attr('aria-hidden', true);
          }
          that.popupShow();
          $(this).css('z-index', 1040 + (10 * idx));
          $overlay.css('z-index', 1039 + (10 * idx));
          $overlay.addClass('stacked').attr('aria-hidden', true);
          App.vent.trigger('popup:shown');
        });
        $popup.on('hidden.bs.modal', function () {
          var idx = ($('.modal:visible').length) - 1;
          $overlay.css('z-index', 1039);
          if ($('.modal').attr('id') === 'oneModal' && idx === 0) {
            $('#oneModal').attr('aria-hidden', false).focus();
          }
          that.popupClose();

          App.vent.trigger('popup:hidden');
        });
      }
      $popup.modal({
        show: true,
        backdrop: 'static',
        keyboard: false
      });
    },
    popupShow : function () {
      var $popup = $(App.popupRegion.$el).find('.modal');
      App.focusPopup();
      if (this.idNum !== '90') {
        $('.container-full').hide();
      }
      $('.container-full').attr('aria-hidden', true);
      $('header').attr('aria-hidden', true);
      $('footer').attr('aria-hidden', true);

    },
    popupClose : function () {
      var $popup = $(App.popupRegion.$el).find('.modal');
      App.focusPopup();
      App.popupRegion.close(this);

      if ($popup.length < 2) {
        if (this.idNum !== '90') {
          App.focusTop();
        } else {
          $('.form-field:last-of-type').focus();
        }
        $('.modal').attr('aria-hidden', true);
        $('header').removeAttr('aria-hidden');
        $('footer').removeAttr('aria-hidden');
        $('.container-full').removeAttr('aria-hidden');
        $('.container-full').show();

      }

    }
  });
});
