define(function (require) {
  var App = require('app');
  var template = require('text!../html/popup/resourceLinkDirectView.html');

  return Backbone.Marionette.ItemView.extend({
    id: 'modalBox',
    tagName: 'div',
    events: {
      'click #ok-btn': 'navigateToExtSite',
      'click .cancel-delete': 'cancelEventTrigger'
    },
    template: _.template(template),
    initialize: function (opts) {
      this.name = opts.name;
      this.link = opts.link;
    },
    serializeData: function () {
      return {
        name: this.name,
        link: this.link
      };
    },
    navigateToExtSite: function () {
      window.open(this.link);
    },
    cancelEventTrigger: function () {
      App.vent.trigger('item:canceldelete');
    }




  });
});
