define(function (require) {
  var App = require('app');
  var template = require('text!../html/pregnancyResourcesView.html');

  return Backbone.Marionette.ItemView.extend({
    id: '',
    tagName: 'div',
    className: 'PR container',
    template: _.template(template),
    header: {
      outer: 'Pregnancy',
      inner: 'Resources'
    },

    events: {
      'click .resourceItem, .purple-book': 'showLinkDirectPopup',
      'tap .resourceItem, .purple-book': 'showLinkDirectPopup'
    },

    initialize: function () {
      var that = this;
      _.bindAll(this, 'showLinkDirectPopup');
      $('.resourceItem').on('click', 'showLinkDirectPopup');
      this.listenTo(App.vent, 'item:canceldelete', function () {
        var $text = $(that.id).text();
        var $aria = $(that.id).attr('aria-label');
        setTimeout(function () {
          if (navigator.platform.indexOf('iPhone') !== -1 || navigator.platform.indexOf('iPad') !== -1) {
            $(that.id).attr('aria-label', $aria);
            $(that.id).text($text);
          }
          $(that.id).focus();
        }, 50);
      });
    },

    onRender: function () {
      //on re-render, prevents the loss of context of this
      this.delegateEvents();
    },
    mobileAria: function (element, phoneListIds) {
      var $text = $(element).text();
      var $aria = $(element).attr('aria-label');
      $(element).attr('aria-label', $text + '.' + $aria);

    },

    onShow: function () {
      var phoneListIds = ['#htline', '#crisisline', '#domline', '#mililine', '#triline', '#poiline'];

      if (navigator.platform.indexOf('iPhone') !== -1 || navigator.platform.indexOf('iPad') !== -1) {
        var ids = ['#pre', '#obgyn', '#socmed', '#lact', '#done', '#milit', '#domviol', '#email', '#pregguide', '#health'];

        for (var i = 0; i < ids.length; i++) {
          this.mobileAria(ids[i]);
        }

        for (var k = 0; k < phoneListIds.length; k++) {
          this.mobileAriaForPhoneList(phoneListIds[k]);
        }
      }
      else {
       //add aria-hidden to the child, remove aria-label from child and add to element
        for (var j = 0; j < phoneListIds.length; j++) {
          var $childElement;
          $childElement = $(phoneListIds[j]).find('.contact');
          $(phoneListIds[j]).attr('aria-label', $childElement.attr('aria-label'));
          $($childElement).removeAttr('aria-label');
          $($childElement).attr('aria-hidden', 'true');
        }
      }
    },

    mobileAriaForPhoneList: function (element) {
      var $childElement = $(element).find('.contact');
      if ($(element).attr !== undefined) {
        $($childElement).attr('aria-label', $(element).attr());
        $(element).removeAttr('aria-label');
        $($childElement).removeAttr('aria-hidden');
      }
    },

    showLinkDirectPopup: function (e) {
      var that = this;
      e.stopPropagation();
      e.preventDefault();
      var id, href;
      href = '#';
      id = e.currentTarget.id;
      this.id = '#' + id;
      if (e.currentTarget.classList.contains('purple-book')) {
        window.open('assets/PurpleBookPregnancyChildbirth.pdf', 'purplebookWindow');
      } else if (e.currentTarget.href) {
        href = e.currentTarget.href;
        App.router.popups.showResourcesLinkDirectPopup({link: href, elemId: id});
      }
    }

  });
});
