define(function (require) {
  var App = require('app');
  var template = require('text!../html/pregnancyTrackerView.html');

  return Backbone.Marionette.ItemView.extend({
    id: '',
    tagName: 'div',
    className: 'container tracker',
    template: _.template(template),
    header: {
      outer: 'Pregnancy',
      inner: 'Tracker'
    },

    onShow: function () {
      this.listenTo(App.vent, 'labs:refresh', this.updateLabsDue);
      this.listenTo(App.vent, 'header:export', this.clickExportBtn);
      $('#export-btn').show();
      App.models.profile.fetch({
        global: false,
        success: function () {
          App.vent.trigger('labs:refresh');
        }
      });
      //$('#export-btn').on('click', this.exportData);

    },
    updateLabsDue: function () {
      if (parseInt(App.models.profile.get('labDueItems')) === 1) {
        $('#labs-due').text(App.models.profile.get('labDueItems') + ' Item Due');
      } else {
        $('#labs-due').text(App.models.profile.get('labDueItems') + ' Items Due');
      }
      var $labs = $('#labs');
      $labs.attr('aria-label', $labs.text());
    },

    clickExportBtn: function () {
      App.router.navigate('export-data');
      App.router.controller.exportPregnTrackerData();
    }
  });
});
