define(function (require) {
  var App = require('app');
  var template = require('text!../html/screeningListView.html');
  var emptyTemplate = require('text!../html/screeningListEmptyView.html');
  var itemTemplate = require('text!../html/screeningListItem.html');


  return Backbone.Marionette.CompositeView.extend({
    id: 'screening-list',
    className: 'list-container',
    tagName: 'div',
    itemView: Backbone.Marionette.ItemView.extend({
      className: 'test-link',
      template: _.template(itemTemplate),
      serializeData: function () {
        return _.extend(this.model.toJSON(), {cid: this.model.cid});
      }
    }),
    emptyView: Backbone.Marionette.ItemView.extend({
      template: _.template(emptyTemplate)
    }),
    itemViewContainer: '#list',
    template: _.template(template),
    header: {
      outer: 'Genetic',
      inner: 'Screening'
    },

    initialize: function () {
      this.collection = App.collections.screenings;
      this.listenTo(App.vent, 'header:add', this.newFormView);
      this.listenTo(App.vent, 'screening:fetch', this.updateAria);
    },
    onShow: function () {
      $('#add-btn').show();
      this.collection.fetch({
        reset: true,
        success: function () {
          App.vent.trigger('screening:fetch');
        }
      });
    },
    updateAria: function () {
      if (this.collection.length < 1) {
        this.$el.find('.list-header').attr('aria-hidden', 'true');
      }
    },
    newFormView: function () {
      App.router.navigate('genetic-screening/new');
      App.router.controller.showScreeningTest('new');
    }

  });
});
