define(function (require) {
  var App = require('app');
  var template = require('text!../html/ultrasoundListView.html');
  var emptyTemplate = require('text!../html/ultrasoundListEmptyView.html');
  var itemTemplate = require('text!../html/ultrasoundListItem.html');


  return Backbone.Marionette.CompositeView.extend({
    id: 'ultrasound-list',
    className: 'list-container',
    tagName: 'div',
    itemView: Backbone.Marionette.ItemView.extend({
      className: 'entry-link',
      template: _.template(itemTemplate),
      serializeData: function () {
        return _.extend(this.model.toJSON(), {cid: this.model.cid, edd: App.models.profile.get('edd')});
      }
    }),
    emptyView: Backbone.Marionette.ItemView.extend({
      template: _.template(emptyTemplate)
    }),
    itemViewContainer: '#list',
    template: _.template(template),
    header: {
      outer: 'Ultrasounds'
    },
    route: 'ultrasound',
    initialize: function () {
      this.collection = App.collections.ultrasounds;
      this.listenTo(App.vent, 'header:add', this.newFormView);
      this.listenTo(App.vent, 'ultrasound:fetch', this.updateAria);
    },
    onShow: function () {
      $('#add-btn').show();
      this.collection.fetch({
        reset: true,
        success: function () {
          App.vent.trigger('ultrasound:fetch');
        }
      });
    },
    updateAria: function () {
      if (this.collection.length < 1) {
        this.$el.find('.list-header').attr('aria-hidden', 'true');
      }
    },
    newFormView: function () {
      App.router.navigate('ultrasound/new');
      App.router.controller.showUltrasoundDetails('new');
    }
  });
});
