require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"
require "rest-client"

class LaunchApp < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    @driver.quit
    assert_equal [], @verification_errors

  end

  def test_Vaccinations

    res = RestClient.post(@base_url+"va-mom-resources/rest/VeteranResource/maintain-db?", { 'maintenanceType' => 'vaMomVaccinationsCollection','code' => '84065','uniqueIdentifier' => '*'}.to_json, :accept => :json, :content_type => :json)
    puts res.code
    puts res.body

    # Logging into VA Moms home page
    accept_eula()
    sleep(5)
    @driver.find_element(:id, "login").click
    sleep(5)
    @driver.find_element(:id, "name-c").clear
    @driver.find_element(:id, "name-c").send_keys "zztest.patient01"
    @driver.find_element(:id, "password").clear
    @driver.find_element(:id, "password").send_keys "pass"
    @driver.find_element(:id, "loginButton").click

    # Verify the name of app, intro text and login button are present in the main page
    assert(@driver.page_source.include?("VA Moms"), "App name not present on home page.")
    string_present = @driver.page_source.include?("Chart your pregnancy")

    # Refresh page after deleting the profile record from database

    if (element_present?(:id, "create") ) then
      # Create new profile
      @driver.find_element(:id, "create").click
      verify {assert(@driver.find_element(:id, "my-profile"), "Unable to find page header")}
      @driver.find_element(:id, "nameFirst").clear
      @driver.find_element(:id, "nameFirst").send_keys "Carol"
      @driver.find_element(:id, "nameLast").clear
      @driver.find_element(:id, "nameLast").send_keys "Smith"
      @driver.find_element(:id, "lmp").clear
      @driver.find_element(:id, "lmp").send_keys "05/01/2014"
      @driver.find_element(:id, "edd").clear
      @driver.find_element(:id, "edd").send_keys "02/05/2015"
      @driver.find_element(:id, "noOfPregs").click
      @driver.find_element(:id, "noOfPregs").send_keys "2"
      @driver.find_element(:id, "noOfDeliveries").click
      @driver.find_element(:id, "noOfDeliveries").send_keys "2"
      @driver.find_element(:id, "wbp").clear
      @driver.find_element(:id, "wbp").send_keys "150"
      @driver.find_element(:id, "currWgt").clear
      @driver.find_element(:id, "currWgt").send_keys "150"
      @driver.find_element(:id, "obProvider").clear
      @driver.find_element(:id, "obProvider").send_keys "Test2"
      @driver.find_element(:id, "obContacts-contactInfo-0").clear
      @driver.find_element(:id, "obContacts-contactType-0").click
      @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "574-345-4567"
      @driver.find_element(:id, "obContacts-contactInfo-0").clear
      @driver.find_element(:id, "obContacts-contactType-0").click
      @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "test"
      @driver.find_element(:id, "mcc").clear
      @driver.find_element(:id, "mcc").send_keys "Phone"
      @driver.find_element(:id, "mccContact").clear
      @driver.find_element(:id, "mccContact").send_keys "2343453456"
      #@driver.find_element(:css, "label.btn.switch").click
      sleep(1)
      @driver.find_element(:id, "email").clear
      @driver.find_element(:id, "email").send_keys "test@longviewinc.com"
      assert_equal("Save",@driver.find_element(:id, "save-btn").text)
      @driver.find_element(:id, "save-btn").click

    end

    # MTS-296 : Create Pregnancy Tracker
    sleep(5)
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(5)
    assert_equal("Pregnancy Tracker",@driver.find_element(:id, "pregnancy-tracker").text)
    verify {assert(@driver.find_element(:partial_link_text, "My Profile"), "Unable to find my profile link")}
    verify {assert(@driver.find_element(:partial_link_text, "Diagnosis"), "Unable to find Diagnosis link")}
    verify {assert(@driver.find_element(:partial_link_text, "Medications this Pregnancy"), "Unable to find Meds this Pregnancy link")}
    verify {assert(@driver.find_element(:partial_link_text, "Allergies"), "Unable to find Allergies this Pregnancy link")}
    verify {assert(@driver.find_element(:partial_link_text, "Labs"), "Unable to find Labs link")}
    verify {assert(@driver.find_element(:partial_link_text, "Ultrasounds"), "Unable to find Ultrasounds link")}
    verify {assert(@driver.find_element(:partial_link_text, "Genetic Screening"), "Unable to find Genetic Screening link")}
    verify {assert(@driver.find_element(:partial_link_text, "Vaccination"), "Unable to find Vaccination link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Outcome"), "Unable to find Pregnancy Outcome link")}

    #MTAV-230 - VACCINATIONS
    @driver.find_element(:partial_link_text, "Vaccination").click
    sleep(5)

    #Verify elements exist on the View
    verify {assert(@driver.find_element(:id, "add-btn"), "The Add Record button does not exist")}
    verify {assert(@driver.find_element(:id, "back-btn"), "The Back button does not exist")}
    verify {assert(@driver.find_element(:id, "app-menu-btn"), "The Application Menu does not exist")}
    verify {assert(@driver.find_element(:id, "fluShotLastAdmin-icon"), "The Flu Shot Last Admin Calendar does not exist")}
    verify {assert(@driver.find_element(:id, "fluShotLastAdmin"), "The Flu Ahot Last Admin date field does not exist")}
    verify {assert(@driver.find_element(:id, "fluShotNextDue-icon"), "The Flu Shot Next Due Calendar does not exist")}
    verify {assert(@driver.find_element(:id, "fluShotNextDue"), "The Flu Shot Next Due date field does not exist")}
    verify {assert(@driver.find_element(:id, "tdapLastAdmin-icon"), "The Tdap Last Admin Calendar not exist")}
    verify {assert(@driver.find_element(:id, "tdapLastAdmin"), "The Tdap Last Admin date field does not exist")}
    verify {assert(@driver.find_element(:id, "tdapNextDue-icon"), "The Tdap Next Due Calendar does not exist")}
    verify {assert(@driver.find_element(:id, "tdapNextDue"), "The TDap Next Due date field does not exist")}
    verify {assert(@driver.find_element(:id, "save-btn"), "The Save button does not exist")}

    #Verify the text elements exist in the View
    assert(@driver.page_source.include?("Flu Shot (Given once during pregnancy when available)"), "The Flu text does not exist on the page.")
    assert(@driver.page_source.include?("Flu Shot Last Administered ( mm/dd/yyyy )"), "The Last Admin Flu Shot text does not exist.")
    assert(@driver.page_source.include?("Flu Shot Next Due ( mm/dd/yyyy )"), "The Next Due Flu Shot text does not exist.")
    assert(@driver.page_source.include?("Tdap Tetanus, Diphtheria and Pertussis (Pregnancy Booster)"), "The Tdap text does not exist.")
    assert(@driver.page_source.include?("Tdap Last Administered ( mm/dd/yyyy )"), "The Tdap last admin text does not exist.")
    assert(@driver.page_source.include?("Tdap Next Due ( mm/dd/yyyy )"), "The Tdap Next Due text does not exist.")


    #Verify the format validations for the date Administered fields
    @driver.find_element(:id, "fluShotLastAdmin").send_keys "2014/01/01"
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    assert(@driver.page_source.include?("Please re-enter date using mm/dd/yyyy format."), "The Flu Last Admin date field format validation does not exist.")
    @driver.find_element(:id, "fluShotLastAdmin").clear
    @driver.find_element(:id, "tdapLastAdmin").send_keys "2014/02/02"
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    assert(@driver.page_source.include?("Please re-enter date using mm/dd/yyyy format."), "The Tdap Last Admin date field format validation does not exist.")
    @driver.find_element(:id, "tdapLastAdmin").clear
    @driver.find_element(:id, "fluShotLastAdmin").send_keys "01/01/2014"
    @driver.find_element(:id, "tdapLastAdmin").send_keys "02/02/2014"
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    assert(@driver.page_source.include?("Pregnancy Tracker"), "The User was not returned to the Pregnancy Tracker page")
    @driver.find_element(:partial_link_text, "Vaccination").click
    sleep(5)
    assert(@driver.page_source.include?("01/01/2014"), "The date of the last flu shot was not saved")
    assert(@driver.page_source.include?("02/02/2014"), "The date of the last Tdap was not saved")
    @driver.find_element(:id, "fluShotLastAdmin").clear
    @driver.find_element(:id, "tdapLastAdmin").clear
    @driver.find_element(:id, "fluShotLastAdmin").send_keys "03/03/2014"
    @driver.find_element(:id, "tdapLastAdmin").send_keys "04/04/2014"
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    @driver.find_element(:partial_link_text, "Vaccination").click
    sleep(5)
    assert(@driver.page_source.include?("03/03/2014"), "The edit of the date of the last flu shot was not saved")
    assert(@driver.page_source.include?("04/04/2014"), "The edit of the date of the last Tdap was not saved")

    #Test the values for tdap Next Due
    twentysevenweeksdate = (Date.today+92).strftime("%m/%d/%Y")
    thirtysevenweeksdate = (Date.today+20).strftime("%m/%d/%Y")
    @driver.find_element(:id, "tdapLastAdmin").clear
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    @driver.find_element(:partial_link_text, "My Profile").click
    @driver.find_element(:id, "edd").clear
    @driver.find_element(:id, "edd").send_keys twentysevenweeksdate
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    @driver.find_element(:partial_link_text, "Vaccination").click
    sleep(5)
    nextduedate = @driver.find_element(:id, "tdapNextDue").attribute("value")
    if nextduedate != (Date.today).strftime("%m/%d/%Y") then
        abort "The Next Due date should be today, but it is not"+(Date.today).strftime("%m/%d/%Y")
    end
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    @driver.find_element(:partial_link_text, "My Profile").click
    @driver.find_element(:id, "edd").clear
    @driver.find_element(:id, "edd").send_keys thirtysevenweeksdate
    @driver.find_element(:id, "save-btn").click
    @driver.find_element(:partial_link_text, "Vaccination").click
    sleep(5)

    notduedate = @driver.find_element(:id, "tdapNextDue").attribute("value")
    if notduedate != "Not Due"
      abort "The Next Due date should be Not Due, but it is "+notduedate
    end

    @driver.find_element(:id, "tdapLastAdmin").clear
    @driver.find_element(:id, "tdapLastAdmin").send_keys "04/04/2014"
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    @driver.find_element(:partial_link_text, "Vaccination").click
    sleep(5)
    currentduedate = @driver.find_element(:id, "tdapNextDue").attribute("value")
    if currentduedate != "Current"
      abort "The Next Due date should be Current, but it is "+currentduedate
    end



    res = RestClient.post(@base_url+"va-mom-resources/rest/VeteranResource/maintain-db?", { 'maintenanceType' => 'vaMomVaccinationsCollection','code' => '84065','uniqueIdentifier' => '*'}.to_json, :accept => :json, :content_type => :json)
    puts res.code
    puts res.body

  end




  def element_present?(how, what)
    @driver.find_element(how, what)
    true
  rescue Selenium::WebDriver::Error::NoSuchElementError
    false
  end

  def alert_present?()
    @driver.switch_to.alert
    true
  rescue Selenium::WebDriver::Error::NoAlertPresentError
    false
  end

  def verify(&blk)
    yield
  rescue Test::Unit::AssertionFailedError => ex
    @verification_errors << ex
  end

  def close_alert_and_get_its_text(how, what)
    alert = @driver.switch_to().alert()
    alert_text = alert.text
    if (@accept_next_alert) then
      alert.accept()
    else
      alert.dismiss()
    end
    alert_text
  ensure
    @accept_next_alert = true
  end
end