require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"
require "rest-client"

class LaunchApp < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    @driver.quit
    assert_equal [], @verification_errors

  end

  def test_create_profile

    res = RestClient.post(@base_url+"va-mom-resources/rest/VeteranResource/maintain-db?", { 'maintenanceType' => 'vaMomProfileCollection','code' => '84065','uniqueIdentifier' => '*'}.to_json, :accept => :json, :content_type => :json)
    puts res.code
    puts res.body


    # MTS-39 Create Profile/ MTAV-590 Make EDD Required field
    # MTAV-595 - Updates to My Profile

    # Logging into VA Moms home page
    accept_eula()
    sleep(2)
    sleep(5)
    assert(@driver.page_source.include?("Any data entered in this app will be shared with"), "Additional confirmation page not dispalyed")
    sleep(5)
    @driver.find_element(:id, "accept-btn").click
    sleep(5)
    @driver.find_element(:id, "login").click
    sleep(5)
    @driver.find_element(:id, "name-c").clear
    @driver.find_element(:id, "name-c").send_keys "zztest.patient01"
    @driver.find_element(:id, "password").clear
    @driver.find_element(:id, "password").send_keys "pass"
    @driver.find_element(:id, "loginButton").click

    # Verify the name of app, intro text and login button are present in the main page
    assert(@driver.page_source.include?("VA Moms"), "App name not present on home page.")
    string_present = @driver.page_source.include?("Chart your pregnancy")
    #assert(string_present, "Info text is not present on home page")

    # Refresh page after deleting the profile record from database

    if (element_present?(:id, "create") ) then
    # Create new profile
    @driver.find_element(:id, "create").click
    sleep(3)
    verify {assert(@driver.find_element(:id, "my-profile"), "Unable to find page header")}
    verify {assert(@driver.find_element(:id, "back-btn"), "The Back button does not exist")}
    verify {assert(@driver.find_element(:id, "app-menu-btn"), "The Application Menu does not exist")}
    verify {assert(@driver.find_element(:id, "user-menu-btn"), "The User Menu does not exist")}
    verify {assert(@driver.find_element(:id, "nameFirst"), "The First Name field does not exist")}
    verify {assert(@driver.find_element(:id, "nameLast"), "The Last Name field does not exist")}
    verify {assert(@driver.find_element(:id, "edd"), "The EDD field does not exist")}
    verify {assert(@driver.find_element(:id, "lmp"), "The LMP field does not exist")}
    verify {assert(@driver.find_element(:id, "noOfPregs"), "The Number of Pregs field does not exist")}
    verify {assert(@driver.find_element(:id, "noOfDeliveries"), "The Number of Deliveries field does not exist")}
    verify {assert(@driver.find_element(:id, "wbp"), "The Weight Before Preg field does not exist")}
    verify {assert(@driver.find_element(:id, "currWgt"), "The Current Weight field does not exist")}
    verify {assert(@driver.find_element(:id, "obProvider"), "The OB Provider field does not exist")}
    verify {assert(@driver.find_element(:id, "obContacts-contactInfo-0"), "The first OB Contacts field does not exist")}
    verify {assert(@driver.find_element(:id, "mcc"), "The MCC field does not exist")}
    verify {assert(@driver.find_element(:id, "mccContact"), "The MCC Phone Number field does not exist")}
    option = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "obContacts-contactType-0"))
    option.select_by(:value, "Email")
    option.select_by(:value, "Website")
    option.select_by(:value, "Phone")
    assert(@driver.page_source.include?("Any data entered in this app will be shared with, but not necessarily reviewed by, your Maternity Care Coordinator (MCC). Please coordinate with your MCC."), "The Work With text does not exist on the page.")
    assert(@driver.page_source.include?("* Required Fields"), "The Required Fields text does not exist.")
    assert(@driver.page_source.include?(" * First Name"), "The First Name text does not exist.")
    assert(@driver.page_source.include?(" * Last Name"), "The Last name text does not exist.")
    assert(@driver.page_source.include?("Last Menstrual Period ( mm/dd/yyyy ) "), "The LMP text does not exist.")
    assert(@driver.page_source.include?(" * Estimated Due Date ( mm/dd/yyyy ) "), "The EDD text does not exist.")
    assert(@driver.page_source.include?("Number of Pregnancies (including this one) "), "The Number of Pregs text does not exist.")
    assert(@driver.page_source.include?("Number of Deliveries"), "The Number of Deliveries text does not exist.")
    assert(@driver.page_source.include?("Weight Before Pregnancy ( pounds ) "), "The Weight Before Pregs text does not exist.")
    assert(@driver.page_source.include?("Current Weight ( pounds ) "), "The Current text does not exist.")
    assert(@driver.page_source.include?("OB Provider"), "The OB Provider text does not exist.")
    assert(@driver.page_source.include?("OB Contact Info"), "The OC Contact Info text does not exist.")
    assert(@driver.page_source.include?("Type"), "The Type text does not exist.")
    assert(@driver.page_source.include?("Maternity Care Coordinator ( MCC ) "), "The MCC text does not exist.")
    assert(@driver.page_source.include?("MCC Phone Number"), "The MCC Phone Number text does not exist.")
    assert(@driver.page_source.include?("Add more contact info"), "The Add More Contacts text does not exist.")
    @driver.find_element(:id, "nameFirst").clear
    @driver.find_element(:id, "nameFirst").send_keys "Carol"
    @driver.find_element(:id, "nameLast").clear
    @driver.find_element(:id, "nameLast").send_keys "Smith"
    @driver.find_element(:id, "lmp").clear
    @driver.find_element(:id, "lmp").send_keys "05/01/2014"
    @driver.find_element(:id, "edd").clear
    @driver.find_element(:id, "edd").send_keys "02/05/2015"
    @driver.find_element(:id, "noOfPregs").click
    @driver.find_element(:id, "noOfPregs").send_keys "2"
    @driver.find_element(:id, "noOfDeliveries").click
    @driver.find_element(:id, "noOfDeliveries").send_keys "2"
    @driver.find_element(:id, "wbp").clear
    @driver.find_element(:id, "wbp").send_keys "150"
    @driver.find_element(:id, "currWgt").clear
    @driver.find_element(:id, "currWgt").send_keys "150"
    @driver.find_element(:id, "obProvider").clear
    @driver.find_element(:id, "obProvider").send_keys "Test2"
    @driver.find_element(:id, "obContacts-contactInfo-0").clear
    @driver.find_element(:id, "obContacts-contactType-0").click
    @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "574-345-4567"
    @driver.find_element(:id, "obContacts-contactInfo-0").clear
    @driver.find_element(:id, "obContacts-contactType-0").click
    @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "test"
    @driver.find_element(:id, "mcc").clear
    @driver.find_element(:id, "mcc").send_keys "Phone"
    @driver.find_element(:id, "mccContact").clear
    @driver.find_element(:id, "mccContact").send_keys "2343453456"
    sleep(1)
    assert_equal("Save",@driver.find_element(:id, "save-btn").text)
    @driver.find_element(:id, "save-btn").click
    sleep(2)
    #verify {assert(@driver.find_element(:xpath, "html/body/div[2]/div/div/h2"), "Unable to profile name")}
    @driver.find_element(:id, "user-menu-btn").click
    sleep(1)
    @driver.find_element(:link, "Logout").click
    sleep(10)
    @driver.find_element(:partial_link_text, "VA Moms").click

    # MTS-276 Navigate user to home page if profile created
    @driver.find_element(:id, "login").click
    sleep(1)
    @driver.find_element(:id, "name-c").clear
    @driver.find_element(:id, "name-c").send_keys "zztest.patient01"
    @driver.find_element(:id, "password").clear
    @driver.find_element(:id, "password").send_keys "pass"
    @driver.find_element(:id, "loginButton").click
    end


    # MTS-296 : Create Pregnancy Tracker
    sleep(10)
    verify {assert(@driver.find_element(:partial_link_text, "My Profile"), "Unable to find my profile link")}
    verify {assert(@driver.find_element(:partial_link_text, "My OB Care Journal"), "Unable to find obcare journal link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Tracker"), "Unable to find Diagnosis link")}
    verify {assert(@driver.find_element(:partial_link_text, "My VA Medical Record"), "Unable to find VA Med record link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Resources"), "Unable to find pregnancy resources link")}
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(5)
    assert_equal("Pregnancy Tracker",@driver.find_element(:id, "pregnancy-tracker").text)
    verify {assert(@driver.find_element(:partial_link_text, "My Profile"), "Unable to find my profile link")}
    verify {assert(@driver.find_element(:partial_link_text, "Health Conditions"), "Unable to find Diagnosis link")}
    verify {assert(@driver.find_element(:partial_link_text, "Medications this Pregnancy"), "Unable to find Meds this Pregnancy link")}
    verify {assert(@driver.find_element(:partial_link_text, "Labs"), "Unable to find Labs link")}
    verify {assert(@driver.find_element(:partial_link_text, "Ultrasounds"), "Unable to find Ultrasounds link")}
    verify {assert(@driver.find_element(:partial_link_text, "Genetic Screening"), "Unable to find Genetic Screening link")}
    verify {assert(@driver.find_element(:partial_link_text, "Vaccination"), "Unable to find Vaccination link")}
    verify {assert(@driver.find_element(:partial_link_text, "Your Pregnancy Outcome"), "Unable to find Pregnancy Outcome link")}

    # Click on the myprofile button
    @driver.find_element(:partial_link_text, "My Profile").click
    sleep(5)

    #Verify the elements exist
    verify {assert(@driver.find_element(:id, "back-btn"), "The Back button does not exist")}
    verify {assert(@driver.find_element(:id, "app-menu-btn"), "The Application Menu does not exist")}
    verify {assert(@driver.find_element(:id, "user-menu-btn"), "The User Menu does not exist")}
    verify {assert(@driver.find_element(:id, "nameFirst"), "The First Name field does not exist")}
    verify {assert(@driver.find_element(:id, "nameLast"), "The Last Name field does not exist")}
    verify {assert(@driver.find_element(:id, "edd"), "The EDD field does not exist")}
    verify {assert(@driver.find_element(:id, "lmp"), "The LMP field does not exist")}
    verify {assert(@driver.find_element(:id, "noOfPregs"), "The Number of Pregs field does not exist")}
    verify {assert(@driver.find_element(:id, "noOfDeliveries"), "The Number of Deliveries field does not exist")}
    verify {assert(@driver.find_element(:id, "wbp"), "The Weight Before Preg field does not exist")}
    verify {assert(@driver.find_element(:id, "currWgt"), "The Current Weight field does not exist")}
    verify {assert(@driver.find_element(:id, "obProvider"), "The OB Provider field does not exist")}
    verify {assert(@driver.find_element(:id, "obContacts-contactInfo-0"), "The first OB Contacts field does not exist")}
    verify {assert(@driver.find_element(:id, "obContacts-remove-btn-0"), "The Remove OB Contact first button does not exist")}
    verify {assert(@driver.find_element(:id, "mcc"), "The MCC field does not exist")}
    verify {assert(@driver.find_element(:id, "mccContact"), "The MCC Phone Number field does not exist")}
    option = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "obContacts-contactType-0"))
    option.select_by(:value, "Email")
    option.select_by(:value, "Website")
    option.select_by(:value, "Phone")


    #Verify the expected text values exist
    assert(@driver.page_source.include?("Any data entered in this app will be shared with, but not necessarily reviewed by, your Maternity Care Coordinator (MCC). Please coordinate with your MCC."), "The Work With text does not exist on the page.")
    assert(@driver.page_source.include?("* Required Fields"), "The Required Fields text does not exist.")
    assert(@driver.page_source.include?(" * First Name"), "The First Name text does not exist.")
    assert(@driver.page_source.include?(" * Last Name"), "The Last name text does not exist.")
    assert(@driver.page_source.include?("Last Menstrual Period ( mm/dd/yyyy ) "), "The LMP text does not exist.")
    assert(@driver.page_source.include?(" * Estimated Due Date ( mm/dd/yyyy ) "), "The EDD text does not exist.")
    assert(@driver.page_source.include?("Number of Pregnancies (including this one) "), "The Number of Pregs text does not exist.")
    assert(@driver.page_source.include?("Number of Deliveries"), "The Number of Deliveries text does not exist.")
    assert(@driver.page_source.include?("Weight Before Pregnancy ( pounds ) "), "The Weight Before Pregs text does not exist.")
    assert(@driver.page_source.include?("Current Weight ( pounds ) "), "The Current text does not exist.")
    assert(@driver.page_source.include?("OB Provider"), "The OB Provider text does not exist.")
    assert(@driver.page_source.include?("OB Contact Info"), "The OC Contact Info text does not exist.")
    assert(@driver.page_source.include?("Type"), "The Type text does not exist.")
    assert(@driver.page_source.include?("Maternity Care Coordinator ( MCC ) "), "The MCC text does not exist.")
    assert(@driver.page_source.include?("MCC Phone Number"), "The MCC Phone Number text does not exist.")
    assert(@driver.page_source.include?("Add more contact info"), "The Add More Contacts text does not exist.")

    #Verify the OB Contact fields do not exist until they are supposed to
    @driver.find_element(:id, "obContacts-add-btn").click
    verify {assert(@driver.find_element(:id, "obContacts-contactInfo-1"), "The second OB Contact fields exists when it should not")}
    verify {assert(@driver.find_element(:id, "obContacts-remove-btn-1"), "The Remove OB Contact second button does not exist")}
    @driver.find_element(:id, "obContacts-add-btn").click
    verify {assert(@driver.find_element(:id, "obContacts-contactInfo-1"), "The second OB Contact fields exists when it should not (2)")}
    verify {assert(@driver.find_element(:id, "obContacts-contactInfo-2"), "The third OB Contact fields exists when it should not (2)")}
    verify {assert(@driver.find_element(:id, "obContacts-remove-btn-1"), "The Remove OB Contact second button does not exist (2)")}
    verify {assert(@driver.find_element(:id, "obContacts-remove-btn-2"), "The Remove OB Contact third button does not exist")}
    @driver.find_element(:id, "obContacts-remove-btn-2").click
    @driver.find_element(:id, "obContacts-remove-btn-1").click


    # Edit some of the profile fields
    @driver.find_element(:id, "nameFirst").clear
    @driver.find_element(:id, "nameFirst").send_keys "Carol"
    @driver.find_element(:id, "nameLast").clear
    @driver.find_element(:id, "nameLast").send_keys "Smith"
    @driver.find_element(:id, "edd").clear
    @driver.find_element(:id, "edd").send_keys "02/05/2015"
    @driver.find_element(:id, "noOfPregs").click
    @driver.find_element(:id, "noOfPregs").send_keys "2"
    @driver.find_element(:id, "noOfDeliveries").click
    @driver.find_element(:id, "noOfDeliveries").send_keys "2"
    @driver.find_element(:id, "wbp").clear
    @driver.find_element(:id, "wbp").send_keys "150"
    @driver.find_element(:id, "currWgt").clear
    @driver.find_element(:id, "currWgt").send_keys "150"
    @driver.find_element(:id, "obProvider").clear
    @driver.find_element(:id, "obProvider").send_keys "Test2"
    @driver.find_element(:id, "obContacts-contactInfo-0").clear
    @driver.find_element(:id, "obContacts-contactType-0").click
    @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "574-345-4567"
    sleep(1)
    @driver.find_element(:id, "obContacts-contactInfo-0").clear
    @driver.find_element(:id, "obContacts-contactType-0").click
    @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "test"
    @driver.find_element(:id, "mcc").clear
    @driver.find_element(:id, "mcc").send_keys "Phone"
    @driver.find_element(:id, "mccContact").clear
    @driver.find_element(:id, "mccContact").send_keys "2343453456"

    # code which tests the i button next to EDD
    @driver.find_element(:id, "edd-info-btn").click
    sleep(5)
    assert(@driver.page_source.include?("Estimated Due Date"), "i button pop up exists next to EDD")
    sleep(2)
    assert(@driver.page_source.include?("Your EDD is your due date"), "Message for i button popup exits next to EDD")
    sleep(2)
    @driver.find_element(:id, "popup-close").click
    sleep(5)
    # code which tests the i button next to MCC
    @driver.find_element(:id, "mcc-info-btn").click
    sleep(5)
    assert(@driver.page_source.include?("Maternity Care Coordinator (MCC)"), "i button pop up exists next to MCC")
    sleep(2)
    assert(@driver.page_source.include?("An MCC functions as a link between you"), "Message for i button popup exits next to MCC")
    sleep(2)
    @driver.find_element(:id, "popup-close").click
    sleep(5)
    # click on save button
    @driver.find_element(:id, "save-btn").click
    sleep(10)

    # After saving the edited profile details will direct to the pregnancy tracker page and there again click on the profile details and look for the new updated values

    @driver.find_element(:id, "pregnancy-tracker").click
    sleep(5)
    assert_equal("Pregnancy Tracker",@driver.find_element(:id, "pregnancy-tracker").text)
    verify {assert(@driver.find_element(:partial_link_text, "My Profile"), "Unable to find my profile link")}
    verify {assert(@driver.find_element(:partial_link_text, "Health Conditions"), "Unable to find Diagnosis link")}
    verify {assert(@driver.find_element(:partial_link_text, "Medications this Pregnancy"), "Unable to find Meds this Pregnancy link")}
    verify {assert(@driver.find_element(:partial_link_text, "Labs"), "Unable to find Labs link")}
    verify {assert(@driver.find_element(:partial_link_text, "Ultrasounds"), "Unable to find Ultrasounds link")}
    verify {assert(@driver.find_element(:partial_link_text, "Genetic Screening"), "Unable to find Genetic Screening link")}
    verify {assert(@driver.find_element(:partial_link_text, "Vaccination"), "Unable to find Vaccination link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Outcome"), "Unable to find Pregnancy Outcome link")}
    @driver.find_element(:partial_link_text, "My Profile").click
    sleep(5)
    assert_equal("Carol",@driver.find_element(:id, "nameFirst").attribute("value"))
    assert_equal("Smith",@driver.find_element(:id, "nameLast").attribute("value"))
    #assert_equal("05/01/2014",@driver.find_element(:id, "lmp").attribute("value"))
    assert_equal("02/05/2015",@driver.find_element(:id, "edd").attribute("value"))
    assert_equal("2",@driver.find_element(:id, "noOfPregs").attribute("value"))
    assert_equal("2",@driver.find_element(:id, "noOfDeliveries").attribute("value"))
    assert_equal("150",@driver.find_element(:id, "wbp").attribute("value"))
    assert_equal("150",@driver.find_element(:id, "currWgt").attribute("value"))

    assert_equal("Phone",@driver.find_element(:id, "mcc").attribute("value"))
    assert_equal("2343453456",@driver.find_element(:id, "mccContact").attribute("value"))

    @driver.find_element(:id, "edd").clear
    @driver.find_element(:id, "mccContact").clear
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    assert(@driver.page_source.include?("Incomplete"), "EDD is a required field ")
    @driver.find_element(:id, "edd").send_keys "02/05/2015"
    @driver.find_element(:id, "mccContact").send_keys "574-345-0001"
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    @driver.find_element(:id, "back-btn").click
    sleep(5)
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(5)
    @driver.find_element(:partial_link_text, "My Profile").click
    sleep(5)

  end
  
  def element_present?(how, what)
    @driver.find_element(how, what)
    true
  rescue Selenium::WebDriver::Error::NoSuchElementError
    false
  end
  
  def alert_present?()
    @driver.switch_to.alert
    true
  rescue Selenium::WebDriver::Error::NoAlertPresentError
    false
  end
  
  def verify(&blk)
    yield
  rescue Test::Unit::AssertionFailedError => ex
    @verification_errors << ex
  end
  
  def close_alert_and_get_its_text(how, what)
    alert = @driver.switch_to().alert()
    alert_text = alert.text
    if (@accept_next_alert) then
      alert.accept()
    else
      alert.dismiss()
    end
    alert_text
  ensure
    @accept_next_alert = true
  end
end
