require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"
require "rest-client"



class LaunchApp < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    @driver.quit
    assert_equal [], @verification_errors

  end

  def test_SelfEntered_Medication

    res = RestClient.post(@base_url+"va-mom-resources/rest/VeteranResource/maintain-db?", { 'maintenanceType' => 'vaMomMedicationsCollection','code' => '84065','uniqueIdentifier' => '*'}.to_json, :accept => :json, :content_type => :json)
    puts res.code
    puts res.body

    # MTS-39 Create Profile

    # Logging into VA Moms home page
    accept_eula()
    sleep(2)
    sleep(5)
    assert(@driver.page_source.include?("Any data entered in this app will be shared with"), "Additional confirmation page not dispalyed")
    sleep(5)
    @driver.find_element(:id, "accept-btn").click
    sleep(5)
    @driver.find_element(:id, "login").click
    sleep(5)
    @driver.find_element(:id, "name-c").clear
    @driver.find_element(:id, "name-c").send_keys "zztest.patient01"
    @driver.find_element(:id, "password").clear
    @driver.find_element(:id, "password").send_keys "pass"
    @driver.find_element(:id, "loginButton").click

    # Verify the name of app, intro text and login button are present in the main page
    assert(@driver.page_source.include?("VA Moms"), "App name not present on home page.")
    string_present = @driver.page_source.include?("Chart your pregnancy")

    # Refresh page after deleting the profile record from database
    if (element_present?(:id, "create") ) then
      # Create new profile
      @driver.find_element(:id, "create").click
      verify {assert(@driver.find_element(:id, "my-profile"), "Unable to find page header")}
      @driver.find_element(:id, "nameFirst").clear
      @driver.find_element(:id, "nameFirst").send_keys "Carol"
      @driver.find_element(:id, "nameLast").clear
      @driver.find_element(:id, "nameLast").send_keys "Smith"
      @driver.find_element(:id, "lmp").clear
      @driver.find_element(:id, "lmp").send_keys "05/01/2014"
      @driver.find_element(:id, "edd").clear
      @driver.find_element(:id, "edd").send_keys "02/05/2015"
      @driver.find_element(:id, "noOfPregs").click
      @driver.find_element(:id, "noOfPregs").send_keys "2"
      @driver.find_element(:id, "noOfDeliveries").click
      @driver.find_element(:id, "noOfDeliveries").send_keys "2"
      @driver.find_element(:id, "wbp").clear
      @driver.find_element(:id, "wbp").send_keys "150"
      @driver.find_element(:id, "currWgt").clear
      @driver.find_element(:id, "currWgt").send_keys "150"
      @driver.find_element(:id, "obProvider").clear
      @driver.find_element(:id, "obProvider").send_keys "Test2"
      @driver.find_element(:id, "obContacts-contactInfo-0").clear
      @driver.find_element(:id, "obContacts-contactType-0").click
      @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "574-345-4567"
      @driver.find_element(:id, "obContacts-contactInfo-0").clear
      @driver.find_element(:id, "obContacts-contactType-0").click
      @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "test"
      @driver.find_element(:id, "mcc").clear
      @driver.find_element(:id, "mcc").send_keys "Phone"
      @driver.find_element(:id, "mccContact").clear
      @driver.find_element(:id, "mccContact").send_keys "2343453456"
      #@driver.find_element(:css, "label.btn.switch").click
      sleep(1)
      assert_equal("Save",@driver.find_element(:id, "save-btn").text)
      @driver.find_element(:id, "save-btn").click
      sleep(2)
    end

    # MTS-296 : Create Pregnancy Tracker
    sleep(10)
    verify {assert(@driver.find_element(:partial_link_text, "My Profile"), "Unable to find my profile link")}
    verify {assert(@driver.find_element(:partial_link_text, "My OB Care Journal"), "Unable to find obcare journal link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Tracker"), "Unable to find Diagnosis link")}
    verify {assert(@driver.find_element(:partial_link_text, "My VA Medical Record"), "Unable to find VA Med record link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Resources"), "Unable to find pregnancy resources link")}
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(5)
    assert_equal("Pregnancy Tracker",@driver.find_element(:id, "pregnancy-tracker").text)
    verify {assert(@driver.find_element(:partial_link_text, "My Profile"), "Unable to find my profile link")}
    verify {assert(@driver.find_element(:partial_link_text, "Health Conditions"), "Unable to find Diagnosis link")}
    verify {assert(@driver.find_element(:partial_link_text, "Medications this Pregnancy"), "Unable to find Meds this Pregnancy link")}
    verify {assert(@driver.find_element(:partial_link_text, "Labs"), "Unable to find Labs link")}
    verify {assert(@driver.find_element(:partial_link_text, "Ultrasounds"), "Unable to find Ultrasounds link")}
    verify {assert(@driver.find_element(:partial_link_text, "Genetic Screening"), "Unable to find Genetic Screening link")}
    verify {assert(@driver.find_element(:partial_link_text, "Vaccination"), "Unable to find Vaccination link")}
    verify {assert(@driver.find_element(:partial_link_text, "Your Pregnancy Outcome"), "Unable to find Pregnancy Outcome link")}

    # Click on the My profile button
    @driver.find_element(:partial_link_text, "Medications this Pregnancy").click
    sleep(5)

    #verify the elements exist
    verify {assert(@driver.find_element(:id, "add-btn"), "The Add Record button does not exist")}
    sleep(1)
    verify {assert(@driver.find_element(:id, "back-btn"), "The Back button does not exist")}
    sleep(1)
    verify {assert(@driver.find_element(:id, "app-menu-btn"), "The Application Menu does not exist")}
    sleep(1)
    verify {assert(@driver.find_element(:id, "user-menu-btn"), "The User Menu does not exist")}
    sleep(1)

  #MTAV 240 and 180
    if (element_present?(:partial_link_text, "AddMedication") ) then
      @driver.find_element(:partial_link_text, "AddMedication").click
      sleep 2
      @driver.find_element(:id, "medicationName").clear
      sleep(1)
      @driver.find_element(:id, "save-btn").click
      sleep(1)
      assert(@driver.page_source.include?("Incomplete"), "validation failed for the Medication Name field")
      sleep(1)
      @driver.find_element(:id, "medicationName").clear
      @driver.find_element(:id, "medicationName").send_keys "AddMedication"
      sleep(1)
      @driver.find_element(:id, "medicationType").click
      @driver.find_element(:id, "medicationType").send_keys "Herbal"
      sleep(1)
      @driver.find_element(:id, "currentlyTaking").click
      sleep(1)
      @driver.find_element(:id, "strength").clear
      @driver.find_element(:id, "strength").send_keys "1000mg"
      sleep(1)
      #@driver.find_element(:id, "frequencyTaken").click
      #@driver.find_element(:id, "frequencyTaken").send_keys "Weekly"
      option = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "frequencyTaken"))
            option.select_by(:value, "Once per Day")
            option.select_by(:value, "2 Times a Day")
            option.select_by(:value, "3 Times a Day")
            option.select_by(:value, "4 Times a Day")
            option.select_by(:value, "Weekly")
            option.select_by(:value, "With Meals")
            option.select_by(:value, "As Needed (PRN)")
      sleep(1)
      @driver.find_element(:id, "instructions").clear
      @driver.find_element(:id, "instructions").send_keys "This is test"
      sleep(1)
      @driver.find_element(:id, "reasonForTaking").clear
      @driver.find_element(:id, "reasonForTaking").send_keys "This is test"
      sleep(1)
      @driver.find_element(:id, "refillsRemaining").clear
      @driver.find_element(:id, "refillsRemaining").send_keys "This is test"
      sleep(1)
      @driver.find_element(:id, "prescriber").clear
      @driver.find_element(:id, "prescriber").send_keys "test"
      sleep(1)
      @driver.find_element(:id, "rxNumber").clear
      @driver.find_element(:id, "rxNumber").send_keys "This is test"
      sleep(1)
      @driver.find_element(:id, "pharmacyName").clear
      @driver.find_element(:id, "pharmacyName").send_keys "This is test"
      sleep(1)
      @driver.find_element(:id, "pharmacyPhoneNumber").clear
      @driver.find_element(:id, "pharmacyPhoneNumber").send_keys "5667896789"
      sleep(1)
      @driver.find_element(:id, "lastRefillDate").clear
      @driver.find_element(:id, "lastRefillDate").send_keys "07/01/2014"
      sleep(1)
      @driver.find_element(:id, "startDate").clear
      @driver.find_element(:id, "startDate").send_keys "07/02/2014"
      sleep(1)
      @driver.find_element(:id, "stopDate").clear
      @driver.find_element(:id, "stopDate").send_keys "05/02/2014"
      sleep(1)
      @driver.find_element(:id, "save-btn").click
      sleep(1)
      assert(@driver.page_source.include?("The stop date of a medication cannot precede its start date"), "validation failed for the test Name field")
      sleep(1)
      @driver.find_element(:id, "stopDate").clear
      @driver.find_element(:id, "stopDate").send_keys "12/02/2014"
      sleep(1)
      @driver.find_element(:id, "unwantedSideEffects").click
      sleep(1)
      @driver.find_element(:id, "comments").clear
      @driver.find_element(:id, "comments").send_keys "This is a test"
      sleep(1)
      @driver.find_element(:id, "save-btn").click
      sleep(1)
      sleep(1)
      assert(@driver.page_source.include?("Currently Taking"), "The text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Instructions"), "The text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("-----"), "The text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("AddMedication"), "The list page should show the edited medication details")
      sleep(1)
    else
      @driver.find_element(:id, "add-btn").click
      sleep(1)

      #verify the elements exist
      verify {assert(@driver.find_element(:id, "back-btn"), "The Back button does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "app-menu-btn"), "The Application Menu does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "user-menu-btn"), "The User Menu does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "medicationName"), "The medication-name input number field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "medicationType"), "The type-of-medication drop-down field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "currentlyTaking"), "The currently-taking input number field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "strength"), "The strength input number field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "frequencyTaken"), "The frequency-taken input number field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "instructions"), "The instructions input number field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "reasonForTaking"), "The reason-for-taking input number field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "refillsRemaining"), "The refills-remaining input number field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "rxNumber"), "The rx-number input number field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "pharmacyName"), "The pharmacy-name input text field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "pharmacyPhoneNumber"), "The pharmacy-phone-number input number field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "lastRefillDate"), "The Calendar button does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "startDate"), "The Calendar button does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "stopDate"), "The Calendar button does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "unwantedSideEffects"), "The describe unwanted side effects input text field does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "comments"), "The comments button does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "deleteMedication"), "The delete-this-medication button does not exist")}
      sleep(1)
      verify {assert(@driver.find_element(:id, "save-btn"), "The Save button does not exist")}
      sleep(5)

      #Verify the text exists on the page
      assert(@driver.page_source.include?("* Required Fields"), "The Required Fields note does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("* Medication Name"), "The Medication Name text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("* Type of Medication"), "The Type of Medication text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Currently Taking"), "The Currently Taking text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Strength"), "The Strength text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Frequency Taken"), "The Frequency Taken text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Instructions"), "The Instructions text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Reason for Taking"), "The Reason for Taking text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Refills Remaining"), "The Refills Remaining text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Rx Number"), "The Rx Number text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Prescriber"), "The Prescriber text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Pharmacy Name"), "The Pharmacy Name text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Pharmacy Phone Number"), "The Pharmacy Phone Number text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Last Refill Date"), "The Last Refill Date text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Start Date"), "The Start Date text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Stop Date"), "The Stop Date text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Side Effects"), "The Unwanted Side Effects text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Comments"), "The Comments text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Delete this Medication"), "The Delete this Medication text does not exist.")
      sleep(5)

      # Enter text into all the fields
      @driver.find_element(:id, "medicationName").clear
      sleep(1)
      @driver.find_element(:id, "save-btn").click
      sleep(1)
      assert(@driver.page_source.include?("Incomplete"), "validation failed for the medication Name field")
      sleep(1)
      @driver.find_element(:id, "medicationName").clear
      @driver.find_element(:id, "medicationName").send_keys "AddMedication"
      sleep(1)
      @driver.find_element(:id, "save-btn").click
      sleep(1)
      assert(@driver.page_source.include?("Incomplete"), "validation failed for the medication Name field")
      sleep(1)
      @driver.find_element(:id, "medicationType").send_keys "Herbal"
      sleep(1)
      @driver.find_element(:id, "currentlyTaking").click
      sleep(1)
      @driver.find_element(:id, "strength").clear
      @driver.find_element(:id, "strength").send_keys "1000mg"
      sleep(1)
      #@driver.find_element(:id, "frequencyTaken").click
      #@driver.find_element(:id, "frequencyTaken").send_keys "Weekly"
      option = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "frequencyTaken"))
            option.select_by(:value, "Weekly")
      sleep(1)
      @driver.find_element(:id, "instructions").clear
      @driver.find_element(:id, "instructions").send_keys "This is test"
      sleep(1)
      @driver.find_element(:id, "reasonForTaking").clear
      @driver.find_element(:id, "reasonForTaking").send_keys "This is test"
      sleep(1)
      @driver.find_element(:id, "refillsRemaining").clear
      @driver.find_element(:id, "refillsRemaining").send_keys "This is test"
      sleep(1)
      @driver.find_element(:id, "rxNumber").clear
      @driver.find_element(:id, "rxNumber").send_keys "This is test"
      sleep(1)
      @driver.find_element(:id, "prescriber").clear
      @driver.find_element(:id, "prescriber").send_keys "This is test"
      sleep(1)
      @driver.find_element(:id, "pharmacyName").clear
      @driver.find_element(:id, "pharmacyName").send_keys "This is test"
      sleep(1)
      @driver.find_element(:id, "pharmacyPhoneNumber").clear
      @driver.find_element(:id, "pharmacyPhoneNumber").send_keys "5667896789"
      sleep(1)
      @driver.find_element(:id, "save-btn").click
      sleep(5)
      @driver.find_element(:partial_link_text, "AddMedication").click
      sleep(5)
      @driver.find_element(:id, "lastRefillDate").clear
      sleep(2)
      @driver.find_element(:id, "lastRefillDate").send_keys "23/01/2014"
      sleep(1)
      @driver.find_element(:id, "save-btn").click
      sleep(1)
      assert(@driver.page_source.include?("Please re-enter date using mm/dd/yyyy format"), "validation failed for the medication Name field")
      sleep(1)
      @driver.find_element(:id, "lastRefillDate").clear
      @driver.find_element(:id, "lastRefillDate").send_keys "01/01/2014"
      sleep(1)
      @driver.find_element(:id, "startDate").clear
      @driver.find_element(:id, "startDate").send_keys "07/02/2014"
      sleep(1)
      @driver.find_element(:id, "stopDate").clear
      @driver.find_element(:id, "stopDate").send_keys "05/02/2014"
      sleep(1)
      @driver.find_element(:id, "save-btn").click
      sleep(1)
      assert(@driver.page_source.include?("The stop date of a medication cannot precede its start date"), "validation failed for the medication Name field")
      sleep(1)
      @driver.find_element(:id, "stopDate").clear
      @driver.find_element(:id, "stopDate").send_keys "08/02/2014"
      sleep(1)
      @driver.find_element(:id, "unwantedSideEffects").click
      sleep(1)
      @driver.find_element(:id, "comments").clear
      @driver.find_element(:id, "comments").send_keys "This is a test"
      sleep(1)
      @driver.find_element(:id, "save-btn").click
      sleep(5)
      assert(@driver.page_source.include?("Currently Taking"), "The text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("Instructions"), "The text does not exist.")
      sleep(1)
      assert(@driver.page_source.include?("AddMedication"), "The list page should show the edited medication details")
      sleep(1)
    end

    # Editing few fields from the Medication details that was entered earlier
    assert(@driver.page_source.include?("Medication"), "validation failed for the medication Name field")
    sleep(5)
    @driver.find_element(:partial_link_text, "AddMedication").click
    sleep(5)
    @driver.find_element(:id, "medicationName").clear
    sleep(5)
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    assert(@driver.page_source.include?("Incomplete"), "validation failed for the medication Name field")
    sleep(5)
    @driver.find_element(:id, "medicationName").clear
    @driver.find_element(:id, "medicationName").send_keys "AddMedication"
    sleep(5)
    @driver.find_element(:id, "medicationType").send_keys "Supplement"
    sleep(5)
    @driver.find_element(:id, "currentlyTaking").click
    sleep(5)
    @driver.find_element(:id, "strength").clear
    @driver.find_element(:id, "strength").send_keys "1500mg"
    sleep(5)
    #@driver.find_element(:id, "frequencyTaken").click
    #@driver.find_element(:id, "frequencyTaken").send_keys "As Needed (PRN)"
    option = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "frequencyTaken"))
          option.select_by(:value, "As Needed (PRN)")
    sleep(5)
    @driver.find_element(:id, "instructions").clear
    @driver.find_element(:id, "instructions").send_keys "This is test"
    sleep(5)
    @driver.find_element(:id, "reasonForTaking").clear
    @driver.find_element(:id, "reasonForTaking").send_keys "This is test"
    sleep(5)
    @driver.find_element(:id, "refillsRemaining").clear
    @driver.find_element(:id, "refillsRemaining").send_keys "This is test"
    sleep(5)
    @driver.find_element(:id, "rxNumber").clear
    @driver.find_element(:id, "rxNumber").send_keys "This is test"
    sleep(5)
    @driver.find_element(:id, "prescriber").clear
    @driver.find_element(:id, "prescriber").send_keys "This is test"
    sleep(5)
    @driver.find_element(:id, "pharmacyName").clear
    sleep(1)
    @driver.find_element(:id, "pharmacyName").send_keys "This is test"
    sleep(5)
    @driver.find_element(:id, "pharmacyPhoneNumber").clear
    @driver.find_element(:id, "pharmacyPhoneNumber").send_keys "5667896789"
    sleep(5)
    @driver.find_element(:id, "lastRefillDate").clear
    @driver.find_element(:id, "lastRefillDate").send_keys "07/01/2014"
    sleep(5)
    @driver.find_element(:id, "startDate").clear
    @driver.find_element(:id, "startDate").send_keys "07/02/2014"
    sleep(5)
    @driver.find_element(:id, "stopDate").clear
    @driver.find_element(:id, "stopDate").send_keys "12/02/2014"
    sleep(5)
    @driver.find_element(:id, "unwantedSideEffects").click
    sleep(5)
    @driver.find_element(:id, "comments").clear
    @driver.find_element(:id, "comments").send_keys "This is a test"
    sleep(5)
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    assert(@driver.page_source.include?("AddMedication"), "The list page should show the edited medication details")
    sleep(5)

    #Verifying the updated fields
    @driver.find_element(:partial_link_text, "AddMedication").click
    sleep(5)
    assert_equal("AddMedication",@driver.find_element(:id, "medicationName").attribute("value"))
    sleep(5)
    #assert_equal("Supplement",@driver.find_element(:id, "medicationType").attribute("value"))
    #sleep(5)
    assert_equal("1500mg",@driver.find_element(:id, "strength").attribute("value"))
    sleep(5)
    assert_equal("As Needed (PRN)",@driver.find_element(:id, "frequencyTaken").attribute("value"))
    sleep(5)
    assert_equal("This is test",@driver.find_element(:id, "instructions").attribute("value"))
    sleep(5)
    assert_equal("This is test",@driver.find_element(:id, "reasonForTaking").attribute("value"))
    sleep(5)
    assert_equal("This is test",@driver.find_element(:id, "refillsRemaining").attribute("value"))
    sleep(5)
    assert_equal("This is test",@driver.find_element(:id, "rxNumber").attribute("value"))
    sleep(5)
    assert_equal("This is test",@driver.find_element(:id, "pharmacyName").attribute("value"))
    sleep(5)
    assert_equal("5667896789",@driver.find_element(:id, "pharmacyPhoneNumber").attribute("value"))
    sleep(5)
    assert_equal("07/01/2014",@driver.find_element(:id, "lastRefillDate").attribute("value"))
    sleep(5)
    assert_equal("07/02/2014",@driver.find_element(:id, "startDate").attribute("value"))
    sleep(5)
    assert_equal("12/02/2014",@driver.find_element(:id, "stopDate").attribute("value"))
    sleep(5)
    assert_equal("This is a test",@driver.find_element(:id, "comments").attribute("value"))
    sleep(10)

    # Deleting the record
   # @driver.find_element(:partial_link_text, "AddMedication").click
    sleep(5)
    verify {assert(@driver.find_element(:id, "deleteMedication"), "The Delete-Yes button does not exist")}
    # sleep(5)
    #verify {assert(@driver.find_element(:id, "deleteMedication-no"), "The Delete-Yes button does not exist")}
    sleep(5)
    @driver.find_element(:id, "deleteMedication").click
    sleep(5)
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    verify {assert(@driver.find_element(:id, "popup-close"), "The Cancel button does not exist")}
    sleep(5)
    verify {assert(@driver.find_element(:id, "delete-btn"), "The Delete confirmation button does not exist")}
    sleep(5)
    assert(@driver.page_source.include?("Delete this "), "The Header text does not exist.")
    sleep(5)
    assert(@driver.page_source.include?("Do you really want to delete this Medication?"), "The Delete confirmation text does not exist.")
    sleep(5)
    @driver.find_element(:id, "popup-close").click
    sleep(5)
    refute(@driver.page_source.include?("Do you really want to delete this Medication?"), "The delete popup did not close.")
    sleep(5)
    @driver.find_element(:id, "deleteMedication").click
    sleep(5)
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    @driver.find_element(:id, "delete-btn").click
    sleep(5)
    refute(@driver.page_source.include?("Do you really want to delete this Medication?"), "The delete popup did not close, 2.")
    sleep(5)
    assert(@driver.page_source.include?("Medications"), "The page title.")
    sleep(5)
    assert(@driver.page_source.include?("Click the"), "The sub title.")
    sleep(5)
    assert(@driver.page_source.include?("button in the top right corner"), "The sub title.")
    sleep(5)

  end

  def element_present?(how, what)
    @driver.find_element(how, what)
    true
  rescue Selenium::WebDriver::Error::NoSuchElementError
    false
  end

  def alert_present?()
    @driver.switch_to.alert
    true
  rescue Selenium::WebDriver::Error::NoAlertPresentError
    false
  end

  def verify(&blk)
    yield
  rescue Test::Unit::AssertionFailedError => ex
    @verification_errors << ex
  end

  def close_alert_and_get_its_text(how, what)
    alert = @driver.switch_to().alert()
    alert_text = alert.text
    if (@accept_next_alert) then
      alert.accept()
    else
      alert.dismiss()
    end
    alert_text
  ensure
    @accept_next_alert = true
  end
end
