require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

class HomePage < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_homepage_not_logged_in
    #MTS-5 Home page
    accept_eula()
    sleep(5)
    assert(@driver.page_source.include?("Any data entered in this app will be shared with"), "Additional confirmation page not dispalyed")
    sleep(5)
    @driver.find_element(:id, "accept-btn").click
    sleep(5)
    # title is VA Moms
    assert_equal("VA Moms", @driver.title, "Title does not match VA Moms")

    # footer contains app name/version and logged in status
    assert_equal("VA Moms v1.0.0",@driver.find_element(:class, "version").text)
    #assert(@driver.find_element(:xpath, "html/body/div[1]/footer/div/span[2]").text.include?('Not logged in'), "Not logged in is not displayed")

    # verify the name of app, intro text and login button are present in the main page
    assert(@driver.page_source.include?("VA Moms"), "App name not present on home page.")
    string_present = @driver.page_source.include?("Chart your pregnancy")
    assert(string_present, "Info text is not present on home page")
    assert(@driver.find_element(:id, "login"), "Login button not present")

  end

end




