require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"
require "rest-client"


class LaunchApp < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    @driver.quit
    assert_equal [], @verification_errors

  end

  def test_Labs

    #Labs Due requires LMP changes, so we must start with a clean Profile
    res = RestClient.post(@base_url+"va-mom-resources/rest/VeteranResource/maintain-db?", { 'maintenanceType' => 'vaMomProfileCollection','code' => '84065','uniqueIdentifier' => '*'}.to_json, :accept => :json, :content_type => :json)
    puts res.code
    puts res.body

    res = RestClient.post(@base_url+"va-mom-resources/rest/VeteranResource/maintain-db?", { 'maintenanceType' => 'vaMomLabsCollection','code' => '84065','uniqueIdentifier' => '*'}.to_json, :accept => :json, :content_type => :json)
    puts res.code
    puts res.body


    # MTS-39 Create Profile

    # Logging into VA Moms home page
    accept_eula()
    sleep(5)
    assert(@driver.page_source.include?("Any data entered in this app will be shared with"), "Additional confirmation page not dispalyed")
    sleep(5)
    @driver.find_element(:id, "accept-btn").click
    sleep(5)
    @driver.find_element(:id, "login").click
    sleep(10)
    @driver.find_element(:id, "name-c").clear
    @driver.find_element(:id, "name-c").send_keys "zztest.patient01"
    @driver.find_element(:id, "password").clear
    @driver.find_element(:id, "password").send_keys "pass"
    @driver.find_element(:id, "loginButton").click
    sleep(10)
    # Verify the name of app, intro text and login button are present in the main page
    assert(@driver.page_source.include?("VA Moms"), "App name not present on home page.")
    string_present = @driver.page_source.include?("Chart your pregnancy")
    #assert(string_present, "Info text is not present on home page")

    # Refresh page after deleting the profile record from database

    todaysdate = (Date.today).strftime("%m/%d/%Y")

    if (element_present?(:id, "create") ) then
      # Create new profile
      @driver.find_element(:id, "create").click
      sleep(10)
      verify {assert(@driver.find_element(:id, "my-profile"), "Unable to find page header")}
      @driver.find_element(:id, "nameFirst").clear
      @driver.find_element(:id, "nameFirst").send_keys "Carol"
      @driver.find_element(:id, "nameLast").clear
      @driver.find_element(:id, "nameLast").send_keys "Smith"
      @driver.find_element(:id, "lmp").clear
      @driver.find_element(:id, "lmp").send_keys ""
      @driver.find_element(:id, "edd").clear
      @driver.find_element(:id, "edd").send_keys todaysdate
      @driver.find_element(:id, "noOfPregs").click
      @driver.find_element(:id, "noOfPregs").send_keys "2"
      @driver.find_element(:id, "noOfDeliveries").click
      @driver.find_element(:id, "noOfDeliveries").send_keys "2"
      @driver.find_element(:id, "wbp").clear
      @driver.find_element(:id, "wbp").send_keys "150"
      @driver.find_element(:id, "currWgt").clear
      @driver.find_element(:id, "currWgt").send_keys "150"
      @driver.find_element(:id, "obProvider").clear
      @driver.find_element(:id, "obProvider").send_keys "Test2"
      @driver.find_element(:id, "obContacts-contactInfo-0").clear
      @driver.find_element(:id, "obContacts-contactType-0").click
      @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "574-345-4567"
      @driver.find_element(:id, "obContacts-contactInfo-0").clear
      @driver.find_element(:id, "obContacts-contactType-0").click
      @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "test"
      @driver.find_element(:id, "mcc").clear
      @driver.find_element(:id, "mcc").send_keys "Phone"
      @driver.find_element(:id, "mccContact").clear
      @driver.find_element(:id, "mccContact").send_keys "2343453456"
      #@driver.find_element(:css, "label.btn.switch").click
      sleep(1)
      assert_equal("Save",@driver.find_element(:id, "save-btn").text)
      @driver.find_element(:id, "save-btn").click
    end
    sleep(12)
    #MTAV-594/723 - Update Labs Form and Update Labs Due Calculation
    assert(@driver.page_source.include?("13 Items Due"), "The Labs Due should state 13 items due (Home), but it does not.")

    # MTS-296 : Create Pregnancy Tracker
    sleep(10)
    verify {assert(@driver.find_element(:partial_link_text, "My Profile"), "Unable to find my profile link")}
    verify {assert(@driver.find_element(:partial_link_text, "My OB Care Journal"), "Unable to find obcare journal link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Tracker"), "Unable to find Diagnosis link")}
    verify {assert(@driver.find_element(:partial_link_text, "My VA Medical Record"), "Unable to find VA Med record link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Resources"), "Unable to find pregnancy resources link")}
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(10)
    assert_equal("Pregnancy Tracker",@driver.find_element(:id, "pregnancy-tracker").text)
    assert(@driver.page_source.include?("13 Items Due"), "The Labs Due should state 13 items due (PT), but it does not.")

    # Click on the Labs button
    @driver.find_element(:partial_link_text, "Labs").click
    sleep(10)


    #Verify the elements exist on the page
    verify {assert(@driver.find_element(:id, "add-btn"), "The Add Record button does not exist")}
    verify {assert(@driver.find_element(:id, "back-btn"), "The Back button does not exist")}
    verify {assert(@driver.find_element(:id, "app-menu-btn"), "The Application Menu does not exist")}
    verify {assert(@driver.find_element(:id, "bloodType"), "The Blood Type dropdown does not exist")}
    verify {assert(@driver.find_element(:id, "rhType"), "The Rh Type dropdown does not exist")}
    verify {assert(@driver.find_element(:id, "antibodyScreen"), "The Antibody Screen dropdown does not exist")}
    verify {assert(@driver.find_element(:id, "papSmear"), "The Pap Smear dropdown does not exist")}
    verify {assert(@driver.find_element(:id, "rubella"), "The Rubella dropdown does not exist")}
    verify {assert(@driver.find_element(:id, "varicella"), "The Varicellia dropdown does not exist")}
    verify {assert(@driver.find_element(:id, "hepatitisB"), "The Hepatitis B dropdown does not exist")}
    verify {assert(@driver.find_element(:id, "gonorrhea"), "The Gonorrhea dropdown does not exist")}
    verify {assert(@driver.find_element(:id, "chlamydia"), "The Chlamydia dropdown does not exist")}
    verify {assert(@driver.find_element(:id, "rpr"), "The RPR dropdown does not exist")}
    verify {assert(@driver.find_element(:id, "add-tests-btn"), "The Add Tests button does not exist")}
    verify {assert(@driver.find_element(:id, "save-btn"), "The Save button does not exist")}

    #Verify the hidden fields are hidden
    pap_smear_comments_is_displayed = nil
    pap_smear_comments_is_displayed = @driver.find_element(:id, "papSmearComment").displayed?
    if pap_smear_comments_is_displayed then
      abort "The Pap Smear Comments field is displayed and it should not be"
    end

    #Verify the required text is on the page
    assert(@driver.page_source.include?("Work with your OB provider or nurse to complete this information"), "The sub title.")
    assert(@driver.page_source.include?("Any fields NOT completed will appear “Due” within the application"), "The sub title.")
    assert(@driver.page_source.include?("Initial Labs"), "The sub title.")
    assert(@driver.page_source.include?("Blood Type"), "The sub title.")
    assert(@driver.page_source.include?("Rh Type"), "The sub title.")
    assert(@driver.page_source.include?("Antibody Screen"), "The sub title.")
    assert(@driver.page_source.include?("Pap Smear"), "The sub title.")
    assert(@driver.page_source.include?("Rubella (German Measles)"), "The sub title.")
    assert(@driver.page_source.include?("Varicella (Chicken Pox)"), "The sub title.")
    assert(@driver.page_source.include?("Hepatitis B Surface Ag"), "The sub title.")
    assert(@driver.page_source.include?("Gonorrhea"), "The sub title.")
    assert(@driver.page_source.include?("Chlamydia"), "The sub title.")
    assert(@driver.page_source.include?("Urine Culture"), "The sub title.")
    assert(@driver.page_source.include?("RPR (Syphilis)"), "The sub title.")

    #Verify the dropdown values
    optionBloodType = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "bloodType"))
    #optionBloodType.select_by(:value, "Please Select An Option")
    optionBloodType.select_by(:value, "O")
    optionBloodType.select_by(:value, "A")
    optionBloodType.select_by(:value, "B")
    optionBloodType.select_by(:value, "AB")
    optionRhType = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "rhType"))
    #optionRhType.select_by(:value, "Please Select An Option")
    optionRhType.select_by(:value, "Positive (+)")
    optionRhType.select_by(:value, "Negative (-)")
    optionAntibodyScreen = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "antibodyScreen"))
    #optionAntibodyScreen.select_by(:value, "Please Select An Option")
    optionAntibodyScreen.select_by(:value, "Positive (+)")
    optionAntibodyScreen.select_by(:value, "Negative (-)")
    optionPapSmear = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "papSmear"))
    #optionPapSmear.select_by(:value, "Please Select An Option")
    optionPapSmear.select_by(:value, "Normal")
    optionPapSmear.select_by(:value, "Abnormal")
    optionRubella = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "rubella"))
    #optionRubella.select_by(:value, "Please Select An Option")
    optionRubella.select_by(:value, "Immune")
    optionRubella.select_by(:value, "Non-Immune")
    optionVaricella = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "varicella"))
    #optionVaricella.select_by(:value, "Please Select An Option")
    optionVaricella.select_by(:value, "Immune by history (History of chicken pox)")
    optionVaricella.select_by(:value, "Immune confirmed by lab test")
    optionVaricella.select_by(:value, "Non-Immune")
    optionHepatitisB = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "hepatitisB"))
    #optionHepatitisB.select_by(:value, "Please Select An Option")
    optionHepatitisB.select_by(:value, "Positive (+)")
    optionHepatitisB.select_by(:value, "Negative (-)")
    optionGonorrhea = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "gonorrhea"))
    #optionGonorrhea.select_by(:value, "Please Select An Option")
    optionGonorrhea.select_by(:value, "Positive (+)")
    optionGonorrhea.select_by(:value, "Negative (-)")
    optionChlamydia = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "chlamydia"))
    #optionChlamydia.select_by(:value, "Please Select An Option")
    optionChlamydia.select_by(:value, "Positive (+)")
    optionChlamydia.select_by(:value, "Negative (-)")
    optionUrineCulture = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "urineCulture"))
    #optionUrineCulture.select_by(:value, "Please Select An Option")
    optionUrineCulture.select_by(:value, "Positive (+)")
    optionUrineCulture.select_by(:value, "Negative (-)")
    optionRprCulture = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "rpr"))
    #optionRprCulture.select_by(:value, "Please Select An Option")
    optionRprCulture.select_by(:value, "Reactive")
    optionRprCulture.select_by(:value, "Non-Reactive")
    #Validation
    @driver.find_element(:id, "glucoseLevel").clear
    sleep(1)
    @driver.find_element(:id, "glucoseLevel").send_keys "1500"
    sleep(1)
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    assert(@driver.page_source.include?("The number entered is outside expected range"), "Please check the value and re-enter")
    sleep(1)
    @driver.find_element(:id, "glucoseLevel").clear
    sleep(1)
    @driver.find_element(:id, "glucoseLevel").send_keys "abc"
    sleep(1)
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    assert(@driver.page_source.include?("Invalid characters. Please re-enter using only numbers."), "Invalid characters")
    sleep(5)
    @driver.find_element(:id, "glucoseLevel").clear
    sleep(1)
    @driver.find_element(:id, "glucoseLevel").send_keys "150"
    sleep(5)

    # Edit some of the labs fields
    @driver.find_element(:id, "rubella").click
    sleep(1)
    @driver.find_element(:id, "rubella").send_keys "Please Select an Option"
    sleep(1)
    optionGttCulture = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "glucoseTolerance"))
    optionGttCulture.select_by(:value, "3 Hour Glucose Test")
    sleep(10)
    option = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "gttStatus"))
    option.select_by(:value, "Normal")
    sleep(1)
    @driver.find_element(:id, "groupBStrep").click
    sleep(1)
    @driver.find_element(:id, "groupBStrep").send_keys "Negative (-)"
    sleep(1)
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    #@driver.find_element(:id, "back-btn").click
    #sleep(5)
    # After saving the edited profile details will direct to the pregnancy tracker page and there again click on the profile details and look for the new updated values
    @driver.find_element(:id, "labs-due").click
    sleep(10)
    #assert_equal("AB",@driver.find_element(:id, "bloodType").attribute("value"))
    #sleep(10)
    assert_equal("Negative (-)",@driver.find_element(:id, "rhType").attribute("value"))
    sleep(10)
    @driver.find_element(:id, "back-btn").click
    sleep(10)
    assert(@driver.page_source.include?("1 Item Due"), "The Labs Due should state 1 items due.")
    sleep(5)
    @driver.find_element(:id, "labs-due").click

    optionBloodType = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "bloodType"))
    optionBloodType.select_by(:value, "")
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    #@driver.find_element(:id, "back-btn").click
    #sleep(5)
    assert(@driver.page_source.include?("2 Items Due"), "The Labs Due should state 2 items due.")
    @driver.find_element(:id, "back-btn").click
    sleep(10)
    assert(@driver.page_source.include?("2 Items Due"), "The Labs Due should state 2 items due.")
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(10)
    @driver.find_element(:partial_link_text, "Labs").click
    sleep(10)
    optionRhType = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "rhType"))
    optionRhType.select_by(:value, "")
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    #@driver.find_element(:id, "back-btn").click
    #sleep(5)
    @driver.find_element(:id, "back-btn").click
    sleep(10)
    assert(@driver.page_source.include?("3 Items Due"), "The Labs Due should state 3 items due.")
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(10)
    @driver.find_element(:partial_link_text, "Labs").click
    sleep(10)
    optionAntibodyScreen = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "antibodyScreen"))
    optionAntibodyScreen.select_by(:value, "")
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    #@driver.find_element(:id, "back-btn").click
    #sleep(5)
    assert(@driver.page_source.include?("4 Items Due"), "The Labs Due should state 4 items due.")
    @driver.find_element(:id, "back-btn").click
    sleep(10)
    assert(@driver.page_source.include?("4 Items Due"), "The Labs Due should state 4 items due.")
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(10)
    @driver.find_element(:partial_link_text, "Labs").click
    sleep(10)
    optionPapSmear = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "papSmear"))
    optionPapSmear.select_by(:value, "")
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    #@driver.find_element(:id, "back-btn").click
    #sleep(5)
    assert(@driver.page_source.include?("5 Items Due"), "The Labs Due should state 5 items due.")
    @driver.find_element(:id, "back-btn").click
    sleep(10)
    assert(@driver.page_source.include?("5 Items Due"), "The Labs Due should state 5 items due.")
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(10)
    @driver.find_element(:partial_link_text, "Labs").click
    sleep(10)
    optionVaricella = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "varicella"))
    optionVaricella.select_by(:value, "")
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    #@driver.find_element(:id, "back-btn").click
    #sleep(5)
    assert(@driver.page_source.include?("6 Items Due"), "The Labs Due should state 6 items due (PT), but it does not (8).")
    @driver.find_element(:id, "back-btn").click
    sleep(10)
    assert(@driver.page_source.include?("6 Items Due"), "The Labs Due should state 6 items due (Home), but it does not (8).")
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(10)
    @driver.find_element(:partial_link_text, "Labs").click
    sleep(10)

    sleep(10)
    optionHepatitisB = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "hepatitisB"))
    optionHepatitisB.select_by(:value, "")
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    #@driver.find_element(:id, "back-btn").click
    #sleep(10)
    assert(@driver.page_source.include?("7 Items Due"), "The Labs Due should state 7 items due.")
    sleep(2)
    @driver.find_element(:id, "back-btn").click
    sleep(10)
    assert(@driver.page_source.include?("7 Items Due"), "The Labs Due should state 7 items due.")
    sleep(2)
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(10)
    @driver.find_element(:partial_link_text, "Labs").click
    sleep(10)
    optionGonorrhea = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "gonorrhea"))
    optionGonorrhea.select_by(:value, "")
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    #@driver.find_element(:id, "back-btn").click
    #sleep(10)
    assert(@driver.page_source.include?("8 Items Due"), "The Labs Due should state 8 items due.")
    sleep(2)
    @driver.find_element(:id, "back-btn").click
    sleep(10)
    assert(@driver.page_source.include?("8 Items Due"), "The Labs Due should state 8 items due).")
    sleep(2)
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(10)
    @driver.find_element(:partial_link_text, "Labs").click
    sleep(10)
    optionChlamydia = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "chlamydia"))
    optionChlamydia.select_by(:value, "")
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    #@driver.find_element(:id, "back-btn").click
    #sleep(10)
    assert(@driver.page_source.include?("9 Items Due"), "The Labs Due should state 9 items due.")
    sleep(2)
    @driver.find_element(:id, "back-btn").click
    sleep(10)
    assert(@driver.page_source.include?("9 Items Due"), "The Labs Due should state 9 items due.")
    sleep(2)
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(10)
    @driver.find_element(:partial_link_text, "Labs").click
    sleep(10)
    optionUrineCulture = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "urineCulture"))
    optionUrineCulture.select_by(:value, "")
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    #@driver.find_element(:id, "back-btn").click
    #sleep(10)
    assert(@driver.page_source.include?("10 Items Due"), "The Labs Due should state 10 items due.")
    sleep(2)
    @driver.find_element(:id, "back-btn").click
    sleep(10)
    assert(@driver.page_source.include?("10 Items Due"), "The Labs Due should state 10 items due.")
    sleep(2)
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(10)
    @driver.find_element(:partial_link_text, "Labs").click
    sleep(10)
    optionRprCulture = Selenium::WebDriver::Support::Select.new(@driver.find_element(:id => "rpr"))
    optionRprCulture.select_by(:value, "")
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    #@driver.find_element(:id, "back-btn").click
    #sleep(10)
    assert(@driver.page_source.include?("11 Items Due"), "The Labs Due should state 11 items due.")
    sleep(2)
    @driver.find_element(:id, "back-btn").click
    sleep(10)
    assert(@driver.page_source.include?("11 Items Due"), "The Labs Due should state 11 items due.")
    sleep(2)
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(10)
    @driver.find_element(:partial_link_text, "Labs").click
    sleep(10)
    glucose_tolerance_is_displayed = nil
    glucose_tolerance_is_displayed = @driver.find_element(:id, "glucoseTolerance").displayed?
    if  !glucose_tolerance_is_displayed then
      abort "The Glucose Tolerance field is displayed and it should not be"
    end
    gtt_results_is_displayed = nil
    gtt_results_is_displayed = @driver.find_element(:id, "gttStatus").displayed?
    if  !gtt_results_is_displayed then
      abort "The GTT Results field is displayed and it should not be"
    end
    glucose_level_is_displayed = nil
    glucose_level_is_displayed = @driver.find_element(:id, "glucoseLevel").displayed?
    if  !glucose_level_is_displayed then
      abort "The glucose level field is displayed and it should not be"
    end
    group_b_strep_is_displayed = nil
    group_b_strep_is_displayed = @driver.find_element(:id, "groupBStrep").displayed?
    if  !group_b_strep_is_displayed then
      abort "The glucose level field is displayed and it should not be"
    end
    #sleep(5)
    #@driver.find_element(:id, "back-btn").click
    sleep(5)
    @driver.find_element(:id, "back-btn").click
end

  def element_present?(how, what)
    @driver.find_element(how, what)
    true
  rescue Selenium::WebDriver::Error::NoSuchElementError
    false
  end

  def alert_present?()
    @driver.switch_to.alert
    true
  rescue Selenium::WebDriver::Error::NoAlertPresentError
    false
  end

  def verify(&blk)
    yield
  rescue Test::Unit::AssertionFailedError => ex
    @verification_errors << ex
  end

  def close_alert_and_get_its_text(how, what)
    alert = @driver.switch_to().alert()
    alert_text = alert.text
    if (@accept_next_alert) then
      alert.accept()
    else
      alert.dismiss()
    end
    alert_text
  ensure
    @accept_next_alert = true
  end
end
