require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

class HomePage < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    @driver.quit
    assert_equal [], @verification_errors
    end

  def test_Launchpad

  #MTS-147 Verify that the VA Moms app icon is displayed on Launchpad
  @driver.get(@launch_pad_url)
  verify {assert(@driver.find_element(:partial_link_text, "VA Moms"), "Unable to find app icon on Launchpad")}

  #MTS-148 On selecting the VA Moms app icon from the launchpad will direct the user to VA Moms app
  @driver.find_element(:partial_link_text, "VA Moms").click
  verify {assert(@driver.find_element(:id, "accept-button"), "Unable to load the VA Moms app from launchpad")}

  end

end