require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

class MobileBlueButton< Test::Unit::TestCase

  # Called before every test method runs. Can be used
  # to set up fixture information.
  def setup

    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []
    set_variables()

  end


  def teardown
    @driver.quit
    assert_equal [], @verification_errors
  end

  def test_MBB
    # MTS-38 Mobile Blue Button

    #Go to Launchpad for Va Moms icon
    @driver.get(@launch_pad_url)
    verify {assert(@driver.find_element(:partial_link_text, "VA Moms"), "Unable to find app icon on Launchpad")}

    #MTS-148 On selecting the VA Moms app icon from the launchpad will direct the user to VA Moms app
    @driver.find_element(:partial_link_text, "VA Moms").click
    @driver.find_element(:id, "accept-button").click
    sleep(5)
    assert(@driver.page_source.include?("Any data entered in this app will be shared with"), "Additional confirmation page not dispalyed")
    sleep(5)
    @driver.find_element(:id, "accept-btn").click
    sleep(5)
    verify{assert(@driver.current_url(),"https://hatest.agilexhealth.com/mbb")}
    veteran_login()
    sleep(5)
    #Go to menu button on the left
    @driver.find_element(:id, "app-menu-btn").click
    sleep(2)
    @driver.find_element(:partial_link_text, "My VA Medical Record").click

    #Verify Open Mobile Blue Button exist
    verify {assert(@driver.find_element(:partial_link_text, "Open Mobile Blue Button"), "Unable to find Mobile Blue Button")}
    @driver.find_element(:partial_link_text, "Open Mobile Blue Button").click
    sleep 1
    verify{assert(@driver.current_url(),"mbb")}
    sleep 2
    @driver.switch_to.window(@driver.window_handles.last())
    verify{assert(@driver.current_url(),"https://hatest.agilexhealth.com/mbb")}

  end

end



