require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"
require "rest-client"


class LaunchApp < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    @driver.quit
    assert_equal [], @verification_errors

  end

  def test_obcare_journal

    # Rest call to ensure all existing entries are deleted
    res = RestClient.post(@base_url+"va-mom-resources/rest/VeteranResource/maintain-db?", { 'maintenanceType' => 'vaMomJournalCollection','code' => '84065','uniqueIdentifier' => '*'}.to_json, :accept => :json, :content_type => :json)
    puts res.code
    puts res.body

    # MTS-39 Create Profile

    # Logging into VA Moms home page
    accept_eula()
    sleep(5)
    assert(@driver.page_source.include?("Any data entered in this app will be shared with"), "Additional confirmation page not dispalyed")
    sleep(5)
    @driver.find_element(:id, "accept-btn").click
    sleep(5)
    @driver.find_element(:id, "login").click
    sleep(5)
    @driver.find_element(:id, "name-c").clear
    @driver.find_element(:id, "name-c").send_keys "zztest.patient01"
    @driver.find_element(:id, "password").clear
    @driver.find_element(:id, "password").send_keys "pass"
    @driver.find_element(:id, "loginButton").click

    # Verify the name of app, intro text and login button are present in the main page
    assert(@driver.page_source.include?("VA Moms"), "App name not present on home page.")
    string_present = @driver.page_source.include?("Chart your pregnancy")

    # Refresh page after deleting the profile record from database
    todaysdate = (Date.today).strftime("%m/%d/%Y")

    if (element_present?(:id, "create") ) then
      # Create new profile
      @driver.find_element(:id, "create").click
      verify {assert(@driver.find_element(:id, "my-profile"), "Unable to find page header")}
      @driver.find_element(:id, "nameFirst").clear
      @driver.find_element(:id, "nameFirst").send_keys "Carol"
      @driver.find_element(:id, "nameLast").clear
      @driver.find_element(:id, "nameLast").send_keys "Smith"
      @driver.find_element(:id, "lmp").clear
      @driver.find_element(:id, "lmp").send_keys ""
      @driver.find_element(:id, "edd").clear
      @driver.find_element(:id, "edd").send_keys todaysdate
      @driver.find_element(:id, "noOfPregs").click
      @driver.find_element(:id, "noOfPregs").send_keys "2"
      @driver.find_element(:id, "noOfDeliveries").click
      @driver.find_element(:id, "noOfDeliveries").send_keys "2"
      @driver.find_element(:id, "wbp").clear
      @driver.find_element(:id, "wbp").send_keys "150"
      @driver.find_element(:id, "currWgt").clear
      @driver.find_element(:id, "currWgt").send_keys "150"
      @driver.find_element(:id, "obProvider").clear
      @driver.find_element(:id, "obProvider").send_keys "Test2"
      @driver.find_element(:id, "obContacts-contactInfo-0").clear
      @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "574-345-4567"
      @driver.find_element(:id, "obContacts-add-btn").click
      sleep(1)
      @driver.find_element(:id, "obContacts-contactInfo-1").clear
      @driver.find_element(:id, "obContacts-contactInfo-1").send_keys "571-435-4786"
      @driver.find_element(:id, "mcc").clear
      @driver.find_element(:id, "mcc").send_keys "Phone"
      @driver.find_element(:id, "mccContact").clear
      @driver.find_element(:id, "mccContact").send_keys "2343453456"
      #@driver.find_element(:css, "label.btn.switch").click
      sleep(1)
      #@driver.find_element(:id, "email").clear
      #@driver.find_element(:id, "email").send_keys "test@longviewinc.com"
      assert_equal("Save",@driver.find_element(:id, "save-btn").text)
      @driver.find_element(:id, "save-btn").click
    end


    # MTS-40 : OB Care Journal
    sleep(10)
    verify {assert(@driver.find_element(:partial_link_text, "My Profile"), "Unable to find my profile link")}
    verify {assert(@driver.find_element(:partial_link_text, "My OB Care Journal"), "Unable to find obcare journal link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Tracker"), "Unable to find Diagnosis link")}
    verify {assert(@driver.find_element(:partial_link_text, "My VA Medical Record"), "Unable to find VA Med record link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Resources"), "Unable to find pregnancy resources link")}
    @driver.find_element(:partial_link_text, "My OB Care Journal").click
    sleep(10)


    # VERIFY THE RECORD IS DELETED AND EVERYTHING IS CLEANED UP
    assert(@driver.page_source.include?("Click the"), "The Press text does not exist 2.")
    #assert(@driver.page_source.include?("you are currently taking or have taken during this pregnancy"), "The enter text does not exist 2.")

  if !(element_present?(:partial_link_text, "Test11") ) then

    verify {assert(@driver.find_element(:id, "ob-care-journal"), "Unable to find text")}

    string_present = @driver.page_source.include?("Take notes")
    assert(string_present, "Unable to find the error message")

    sleep(1)

    @driver.find_element(:id, "add-btn").click

    verify {assert(@driver.find_element(:id, "journal-entry"), "Unable to find page header")}

    sleep(10)

    # Create new journal entry
    @driver.find_element(:id, "appointmentDate").clear
    @driver.find_element(:id, "entryTitle").clear
    @driver.find_element(:id, "entryTitle").send_keys "Test11"
    @driver.find_element(:id, "save-btn").click
    sleep 2
    assert(@driver.page_source.include?("Incomplete"), "Appointment date field is incomplete ")
    @driver.find_element(:id, "entryTitle").clear
    @driver.find_element(:id, "appointmentDate").clear
    @driver.find_element(:id, "appointmentDate").send_keys "12/01/2013"
    @driver.find_element(:id, "save-btn").click
    sleep 2
    assert(@driver.page_source.include?("Incomplete"), "Entry Title  field is incomplete ")
    @driver.find_element(:id, "appointmentDate").clear
    @driver.find_element(:id, "entryTitle").clear

    @driver.find_element(:id, "bloodPressure-sys").clear
    @driver.find_element(:id, "bloodPressure-sys").send_keys "12"
    @driver.find_element(:id, "save-btn").click
    sleep 2
    assert(@driver.page_source.include?("The number entered is outside expected range"), "Blood pressure sys is outside the range ")
    @driver.find_element(:id, "bloodPressure-sys").clear
    @driver.find_element(:id, "bloodPressure-dia").clear
    @driver.find_element(:id, "bloodPressure-dia").send_keys "1500"
    @driver.find_element(:id, "save-btn").click
    sleep 2
    assert(@driver.page_source.include?("The number entered is outside expected range"), "Blood pressure dia is outside the range ")

    @driver.find_element(:id, "bloodPressure-sys").clear
    @driver.find_element(:id, "bloodPressure-dia").clear
    @driver.find_element(:id, "currWgt").clear
    @driver.find_element(:id, "currWgt").send_keys "1500"
    @driver.find_element(:id, "save-btn").click
    assert(@driver.page_source.include?("Please check the number and re-enter"), "Current wgt is outside the range ")
    @driver.find_element(:id, "currWgt").clear
    @driver.find_element(:id, "currWgt").send_keys "150"
    sleep 2
    verify {assert(@driver.find_element(:id, "fetalHeartBeatPresent"), "The Delete-Yes button does not exist")}
    #verify {assert(@driver.find_element(:id, "fetalHeartBeatPresent-no"), "The Delete-No button does not exist")}
    @driver.find_element(:id, "fetalHeartBeatPresent").click
    sleep 2
    @driver.find_element(:id, "fundalHeight").clear
    @driver.find_element(:id, "fundalHeight").send_keys "10"
    @driver.find_element(:id, "save-btn").click
    assert(@driver.page_source.include?("The number entered is outside"), "fundal height is outside the range ")
    @driver.find_element(:id, "fundalHeight").clear


    @driver.find_element(:id, "appointmentDate").send_keys "12/01/2013"
    @driver.find_element(:id, "entryTitle").clear
    @driver.find_element(:id, "entryTitle").send_keys "Test11"
    @driver.find_element(:id, "providerName").clear
    @driver.find_element(:id, "providerName").send_keys "Smith"
    @driver.find_element(:id, "visitReason").clear
    @driver.find_element(:id, "visitReason").send_keys "test"
    @driver.find_element(:id, "visitNotes").clear
    @driver.find_element(:id, "visitNotes").send_keys "Test12"
    @driver.find_element(:id, "bloodPressure-sys").clear
    @driver.find_element(:id, "bloodPressure-sys").send_keys "150"
    @driver.find_element(:id, "bloodPressure-dia").clear
    @driver.find_element(:id, "bloodPressure-dia").send_keys "120"
    @driver.find_element(:id, "currWgt").clear
    @driver.find_element(:id, "currWgt").send_keys "150"
    #@driver.find_element(:css, "label.btn.switch").click
    sleep(2)
   # @driver.find_element(:css, "label.btn.switch").click
   # @driver.find_element(:id, "fetalHeartRate").clear
   # @driver.find_element(:id, "fetalHeartRate").send_keys "Test13"
    @driver.find_element(:id, "fundalHeight").clear
    @driver.find_element(:id, "fundalHeight").send_keys "30"
    @driver.find_element(:id, "pregRelatedProblems").clear
    @driver.find_element(:id, "pregRelatedProblems").send_keys "Test14"

    # click on save button

    @driver.find_element(:id, "save-btn").click

  end
    sleep(10)
    @driver.find_element(:partial_link_text, "Test11").click

    # After saving the edited profile details will direct to the pregnancy tracker page and there again click on the profile details and look for the new updated values
    @driver.find_element(:id, "appointmentDate").clear
    @driver.find_element(:id, "entryTitle").clear
    @driver.find_element(:id, "entryTitle").send_keys "Test11"
    @driver.find_element(:id, "save-btn").click
    sleep 2
    assert(@driver.page_source.include?("Incomplete"), "Appointment date field is incomplete ")
    @driver.find_element(:id, "entryTitle").clear
    @driver.find_element(:id, "appointmentDate").clear
    @driver.find_element(:id, "appointmentDate").send_keys "12/01/2013"
    @driver.find_element(:id, "save-btn").click
    sleep 2
    assert(@driver.page_source.include?("Incomplete"), "Entry Title  field is incomplete ")
    @driver.find_element(:id, "appointmentDate").clear
    @driver.find_element(:id, "entryTitle").clear

    @driver.find_element(:id, "bloodPressure-sys").clear
    @driver.find_element(:id, "bloodPressure-sys").send_keys "12"
    @driver.find_element(:id, "save-btn").click
    sleep 2
    assert(@driver.page_source.include?("The number entered is outside expected range"), "Blood pressure sys is outside the range ")
    @driver.find_element(:id, "bloodPressure-sys").clear
    @driver.find_element(:id, "bloodPressure-dia").clear
    @driver.find_element(:id, "bloodPressure-dia").send_keys "1500"
    @driver.find_element(:id, "save-btn").click
    sleep 2
    assert(@driver.page_source.include?("The number entered is outside expected range"), "Blood pressure dia is outside the range ")

    @driver.find_element(:id, "bloodPressure-sys").clear
    @driver.find_element(:id, "bloodPressure-dia").clear
    @driver.find_element(:id, "currWgt").clear
    @driver.find_element(:id, "currWgt").send_keys "1500"
    @driver.find_element(:id, "save-btn").click
    assert(@driver.page_source.include?("Please check the number and re-enter"), "Current wgt is outside the range ")
    @driver.find_element(:id, "currWgt").clear
    sleep 2
    #@driver.find_element(:css, "label.btn.switch").click
    @driver.find_element(:id, "fundalHeight").clear
    @driver.find_element(:id, "fundalHeight").send_keys "10"
    @driver.find_element(:id, "save-btn").click
    assert(@driver.page_source.include?("The number entered is outside"), "fundal height is outside the range ")
    @driver.find_element(:id, "fundalHeight").clear

    @driver.find_element(:id, "back-btn").click
    sleep 2
    @driver.find_element(:partial_link_text, "Test11").click
    assert_equal("Journal Entry",@driver.find_element(:id, "journal-entry").text)
    assert_equal("12/01/2013",@driver.find_element(:id, "appointmentDate").attribute("value"))
    assert_equal("Test11",@driver.find_element(:id, "entryTitle").attribute("value"))
    assert_equal("Smith",@driver.find_element(:id, "providerName").attribute("value"))
    assert_equal("test",@driver.find_element(:id, "visitReason").attribute("value"))
    assert_equal("Test12",@driver.find_element(:id, "visitNotes").attribute("value"))
    assert_equal("150",@driver.find_element(:id, "bloodPressure-sys").attribute("value"))
    assert_equal("120",@driver.find_element(:id, "bloodPressure-dia").attribute("value"))
    assert_equal("150",@driver.find_element(:id, "currWgt").attribute("value"))
    #assert_equal("Test13",@driver.find_element(:id, "fetalHeartRate").attribute("value"))
    assert_equal("30",@driver.find_element(:id, "fundalHeight").attribute("value"))
    assert_equal("Test14",@driver.find_element(:id, "pregRelatedProblems").attribute("value"))
    @driver.find_element(:id, "save-btn").click
    sleep(5)

    #Edit

    @driver.find_element(:partial_link_text, "Test11").click
    @driver.find_element(:id, "providerName").clear
    @driver.find_element(:id, "providerName").send_keys "Smith"
    @driver.find_element(:id, "visitReason").clear
    @driver.find_element(:id, "visitReason").send_keys "test"
    @driver.find_element(:id, "save-btn").click
    sleep(5)

    # After saving the edited profile details
    @driver.find_element(:partial_link_text, "Test11").click
    sleep(5)
    assert_equal("Smith",@driver.find_element(:id, "providerName").attribute("value"))
    sleep(5)
    assert_equal("test",@driver.find_element(:id, "visitReason").attribute("value"))
    sleep(5)
    @driver.find_element(:id, "save-btn").click
    sleep (5)

    # Creating the new journal entry

    @driver.find_element(:id, "add-btn").click

    verify {assert(@driver.find_element(:id, "journal-entry"), "Unable to find page header")}

    sleep(5)

    # MTAV-593 OB Care Journal Fixes
    # Create new journal entry
    @driver.find_element(:id, "appointmentDate").send_keys "01/01/2014"
    @driver.find_element(:id, "save-btn").click
    @driver.find_element(:id, "entryTitle").clear
    @driver.find_element(:id, "entryTitle").send_keys "Test12"
    @driver.find_element(:id, "save-btn").click
    sleep(10)
    verify {assert(@driver.find_element(:id, "entry-0"), "The first link does not exist")}
    sleep (5)
    assert((@driver.find_element(:id, "entry-0").text.include?("Test12")), "The first record was not what was expected")
    sleep (5)
    verify {assert(@driver.find_element(:id, "entry-1"), "The second link does not exist")}
    sleep (5)
    assert((@driver.find_element(:id, "entry-1").text.include?("Test11")), "The second record was not what was expected")
    sleep (5)

    # MTAV-593 OB Care Journal Fixes
    # Rest call to ensure all existing entries are deleted
    res = RestClient.post(@base_url+"va-mom-resources/rest/VeteranResource/maintain-db?", { 'maintenanceType' => 'vaMomJournalCollection','code' => '84065','uniqueIdentifier' => '*'}.to_json, :accept => :json, :content_type => :json)
    puts res.code
    puts res.body


  end

  def element_present?(how, what)
    @driver.find_element(how, what)
    true
  rescue Selenium::WebDriver::Error::NoSuchElementError
    false
  end

  def alert_present?()
    @driver.switch_to.alert
    true
  rescue Selenium::WebDriver::Error::NoAlertPresentError
    false
  end

  def verify(&blk)
    yield
  rescue Test::Unit::AssertionFailedError => ex
    @verification_errors << ex
  end

  def close_alert_and_get_its_text(how, what)
    alert = @driver.switch_to().alert()
    alert_text = alert.text
    if (@accept_next_alert) then
      alert.accept()
    else
      alert.dismiss()
    end
    alert_text
  ensure
    @accept_next_alert = true
  end
end

