require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"

class MobileBlueButton< Test::Unit::TestCase

  def setup

    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []
    set_variables()

  end
  
  def teardown
    @driver.quit
    assert_equal [], @verification_errors
  end
  
  def test_page_header
    # MTS-263 Add Back button to Header

    # Logging into the app
    @driver.get(@launch_pad_url)
    verify {assert(@driver.find_element(:partial_link_text, "VA Moms"), "Unable to find app icon on Launchpad")}
    @driver.find_element(:partial_link_text, "VA Moms").click
    accept_eula()
    sleep(5)
    assert(@driver.page_source.include?("Any data entered in this app will be shared with"), "Additional confirmation page not dispalyed")
    sleep(5)
    @driver.find_element(:id, "accept-btn").click
    sleep(5)
    @driver.find_element(:id, "login").click
    sleep(1)
    @driver.find_element(:id, "name-c").clear
    @driver.find_element(:id, "name-c").send_keys "zztest.patient01"
    @driver.find_element(:id, "password").clear
    @driver.find_element(:id, "password").send_keys "pass"
    @driver.find_element(:id, "loginButton").click
    sleep(2)
    @driver.find_element(:id, "user-menu-btn").click
    sleep(5)

    # Verify the header on each page
    @driver.find_element(:partial_link_text, "About").click
    sleep(1)
    verify {assert(@driver.find_element(:id, "about"), "Unable to find page header")}
    sleep(1)
    @driver.find_element(:id, "back-btn").click
    sleep(1)
    @driver.find_element(:id, "app-menu-btn").click
    sleep(1)
    @driver.find_element(:link, "My VA Medical Record").click
    sleep(1)
    verify {assert(@driver.find_element(:id, "my-va-medical-record"), "Unable to find page header")}
    sleep(1)
    @driver.find_element(:id, "back-btn").click
    sleep(1)
    @driver.find_element(:id, "user-menu-btn").click
    sleep(1)
    @driver.find_element(:link, "Logout").click
    sleep(1)
  end
  
  def element_present?(how, what)
    @driver.find_element(how, what)
    true
  rescue Selenium::WebDriver::Error::NoSuchElementError
    false
  end
  
  def alert_present?()
    @driver.switch_to.alert
    true
  rescue Selenium::WebDriver::Error::NoAlertPresentError
    false
  end
  
  def verify(&blk)
    yield
  rescue Test::Unit::AssertionFailedError => ex
    @verification_errors << ex
  end
  
  def close_alert_and_get_its_text(how, what)
    alert = @driver.switch_to().alert()
    alert_text = alert.text
    if (@accept_next_alert) then
      alert.accept()
    else
      alert.dismiss()
    end
    alert_text
  ensure
    @accept_next_alert = true
  end
end
