require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"
require "rest-client"


class LaunchApp < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    @driver.quit
    assert_equal [], @verification_errors

  end

  def test_PregnancyResources

    res = RestClient.post(@base_url+"va-mom-resources/rest/VeteranResource/maintain-db?", { 'maintenanceType' => 'vaMomProfileCollection','code' => '84065','uniqueIdentifier' => '*'}.to_json, :accept => :json, :content_type => :json)
    puts res.code
    puts res.body

    # MTAV- 228/227/226

    # Logging into VA Moms home page
    accept_eula()
    sleep(5)
    assert(@driver.page_source.include?("Any data entered in this app will be shared with"), "Additional confirmation page not dispalyed")
    sleep(5)
    @driver.find_element(:id, "accept-btn").click
    sleep(5)
    @driver.find_element(:id, "login").click
    sleep(5)
    @driver.find_element(:id, "name-c").clear
    @driver.find_element(:id, "name-c").send_keys "zztest.patient01"
    @driver.find_element(:id, "password").clear
    @driver.find_element(:id, "password").send_keys "pass"
    @driver.find_element(:id, "loginButton").click

    # Verify the name of app, intro text and login button are present in the main page
    assert(@driver.page_source.include?("VA Moms"), "App name not present on home page.")
    string_present = @driver.page_source.include?("Chart your pregnancy")

    # Refresh page after deleting the profile record from database
    if (element_present?(:id, "create") ) then
      # Create new profile
      @driver.find_element(:id, "create").click
      verify {assert(@driver.find_element(:id, "my-profile"), "Unable to find page header")}
      @driver.find_element(:id, "nameFirst").clear
      @driver.find_element(:id, "nameFirst").send_keys "Carol"
      @driver.find_element(:id, "nameLast").clear
      @driver.find_element(:id, "nameLast").send_keys "Smith"
      @driver.find_element(:id, "lmp").clear
      @driver.find_element(:id, "lmp").send_keys "05/01/2014"
      @driver.find_element(:id, "edd").clear
      @driver.find_element(:id, "edd").send_keys "02/05/2015"
      @driver.find_element(:id, "noOfPregs").click
      @driver.find_element(:id, "noOfPregs").send_keys "2"
      @driver.find_element(:id, "noOfDeliveries").click
      @driver.find_element(:id, "noOfDeliveries").send_keys "2"
      @driver.find_element(:id, "wbp").clear
      @driver.find_element(:id, "wbp").send_keys "150"
      @driver.find_element(:id, "currWgt").clear
      @driver.find_element(:id, "currWgt").send_keys "150"
      @driver.find_element(:id, "obProvider").clear
      @driver.find_element(:id, "obProvider").send_keys "Test2"
      @driver.find_element(:id, "obContacts-contactInfo-0").clear
      @driver.find_element(:id, "obContacts-contactType-0").click
      @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "574-345-4567"
      @driver.find_element(:id, "obContacts-contactInfo-0").clear
      @driver.find_element(:id, "obContacts-contactType-0").click
      @driver.find_element(:id, "obContacts-contactInfo-0").send_keys "test"
      @driver.find_element(:id, "mcc").clear
      @driver.find_element(:id, "mcc").send_keys "Phone"
      @driver.find_element(:id, "mccContact").clear
      @driver.find_element(:id, "mccContact").send_keys "2343453456"
      sleep(1)
      assert_equal("Save",@driver.find_element(:id, "save-btn").text)
      @driver.find_element(:id, "save-btn").click
    end

    # MTS-296 : Create Pregnancy Tracker
    sleep(10)
    verify {assert(@driver.find_element(:partial_link_text, "My Profile"), "Unable to find my profile link")}
    verify {assert(@driver.find_element(:partial_link_text, "My OB Care Journal"), "Unable to find obcare journal link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Tracker"), "Unable to find Diagnosis link")}
    verify {assert(@driver.find_element(:partial_link_text, "My VA Medical Record"), "Unable to find VA Med record link")}
    verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Resources"), "Unable to find pregnancy resources link")}

    # Click on the myprofile button
    @driver.find_element(:partial_link_text, "Pregnancy Resources").click

    #verify the elements exist
    verify {assert(@driver.find_element(:id, "back-btn"), "The Back button does not exist")}
    verify {assert(@driver.find_element(:id, "app-menu-btn"), "The Application Menu does not exist")}
    verify {assert(@driver.find_element(:id, "user-menu-btn"), "The User Menu does not exist")}
    verify {assert(@driver.find_element(:id, "pregnancy-resources"), "The pregnancy-resources text does not exist")}
    verify {assert(@driver.find_element(:id, "purple-book"), "The purple-book text does not exist")}
    sleep(2)

    #verify the text exists on the page
    assert(@driver.page_source.include?("Adobe Reader"), "The Adobe text does not exist.")
    assert(@driver.page_source.include?("Phone Numbers"), "The phone numbers text does not exist.")
    assert(@driver.page_source.include?("VA Women's Hotline"), "The VA Women's Hotline text does not exist.")
    assert(@driver.page_source.include?("Veteran's Crisis Line"), "The Veteran's Crisis Line text does not exist.")
    assert(@driver.page_source.include?("National Domestic Violence Hotline"), "The National Domestic Violence Hotline text does not exist.")
    assert(@driver.page_source.include?("Military One Source"), "The Military One Source text does not exist.")
    assert(@driver.page_source.include?("TriCare"), "The TriCare text does not exist.")
    assert(@driver.page_source.include?("Poison Control "), "The Poison Control text does not exist.")
    assert(@driver.page_source.include?("Web Sites"), "The Web Sites text does not exist.")
    assert(@driver.page_source.include?("Pregnancy A to Z"), "The Pregnancy A to Z text does not exist.")
    assert(@driver.page_source.include?("American College of OB/GYN"), "The American College of OB/GYN text does not exist.")
    assert(@driver.page_source.include?("Society for Maternal Fetal Medicine"), "The Society for Maternal Fetal Medicine text does not exist.")
    assert(@driver.page_source.include?("International Lactation Consultants"), "The International Lactation Consultants text does not exist.")
    assert(@driver.page_source.include?("DONA International (Doula's)"), "The DONA International (Doula's) text does not exist.")
    assert(@driver.page_source.include?("Military One Source"), "The Military One Source text does not exist.")
    assert(@driver.page_source.include?("National Domestic Violence Hotline"), "The National Domestic Violence Hotline text does not exist.")
    assert(@driver.page_source.include?("Weekly Pregnancy/Parenting emails"), "The Weekly Pregnancy/Parenting emails text does not exist.")
    assert(@driver.page_source.include?("VA/DoD Pregnancy Guideline"), "The VA/DoD Pregnancy Guideline text does not exist.")
    assert(@driver.page_source.include?("VA Health Topics"), "The VA Health Tops text does not exist.")
    assert(@driver.page_source.include?("text4baby"), "The text4baby text does not exist.")
    assert(@driver.page_source.include?("MotherToBaby"), "The MotherToBaby text does not exist.")
    assert(@driver.page_source.include?("CDC - Pregnancy"), "The CDC - Pregnancy text does not exist.")
    sleep(2)

    #Verify number exists
    assert(@driver.page_source.include?("1-855-VA-Women"), "The 1-855-VA-Women number does not exist.")
    sleep(2)
    assert(@driver.page_source.include?("1-800-273-8255"), "The 1-800-273-8255 number does not exist.")
    sleep(2)
    assert(@driver.page_source.include?("press 1"), "The press 1 number does not exist.")
    sleep(2)
    assert(@driver.page_source.include?("1-800-799-SAFE(7233)"), "The 1-800-799-SAFE(7233) number does not exist.")
    sleep(2)
    assert(@driver.page_source.include?("1-800-342-9647"), "The 1-800-342-9647 number does not exist.")
    sleep(2)
    assert(@driver.page_source.include?("1-800-444-5445"), "The 1-800-444-5445 number does not exist.")
    sleep(2)
    assert(@driver.page_source.include?("1-800-222-1222"), "The 1-800-222-1222 number does not exist.")
    sleep(2)

    # @driver.find_element(:id, "back-btn").click
    # @driver.find_element(:partial_link_text, "Pregnancy Resources").click

    # Verify the purple book button
    #@driver.find_element(:id, "purple-book").click
    #@driver.find_element(:id, "purple-book").send_keys(:command, :return)
    @driver.find_element(:id, "purple-book").click
    sleep(5)
    #body = @driver.find_element(:tag_name => 'body')
    #body.send_keys(:command, 't')
    #@driver.find_element(:id, "ok-btn").send_keys(:command, 't')
    #@driver.find_element(:id, "ok-btn").send_keys(:command, :return)
    # @driver.find_element(by.linkText("urlLink")).send_keys(:command, :return)
    #@driver.find_element(:id, "ok-btn").click
    # String selectLinkOpeninNewTab = Keys.chord(Keys.CONTROL,Keys.RETURN);
    #driver.findElement(By.linkText("urlLink")).sendKeys(selectLinkOpeninNewTab);
    #@driver.switchTo().focuswindow("purplebookWindow")
    #sleep(5)
    #assert(@driver.page_source.include?("Pregnancy and Childbirth"), "The Pregnancy and Childbirth text does not exist.")
    #sleep(2)
    ## Verify all links are opening in a seperate tab and closing it
    @driver.find_element(:id, "pre").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    sleep(2)
    #@driver.find_element(:link, "American College of OB/GYN").click
    @driver.find_element(:id, "obgyn").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    sleep(2)
    @driver.find_element(:id, "socmed").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    sleep(2)
    @driver.find_element(:id, "lact").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    #sleep(2)
    #@driver.navigate.back()
    sleep(2)
    @driver.find_element(:id, "dona").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    #sleep(2)
    #@driver.navigate.back()
    sleep(2)
    @driver.find_element(:id, "milit").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    #sleep(2)
    #@driver.navigate.back()
    sleep(2)
    @driver.find_element(:id, "domviol").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    #sleep(2)
    #@driver.navigate.back()
    sleep(2)
    @driver.find_element(:id, "email").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    #sleep(2)
    #@driver.navigate.back()
    sleep(2)
    @driver.find_element(:id, "pregguide").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    #sleep(2)
    #@driver.navigate.back()
    sleep(2)
    @driver.find_element(:id, "health").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    #sleep(2)
    #@driver.navigate.back()
    sleep(2)
    @driver.find_element(:id, "text4baby").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    #sleep(2)
    #@driver.navigate.back()
    sleep(2)
    @driver.find_element(:id, "mothertobaby").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    #sleep(2)
    #@driver.navigate.back()
    sleep(2)
    @driver.find_element(:id, "cdcpreg").click
    sleep(2)
    @driver.find_element(:id, "ok-btn").click
    #sleep(2)
    #@driver.navigate.back()
    sleep(2)

    # Verify the purple book button
    @driver.find_element(:id, "purple-book").click
    #sleep(2)
    #@driver.navigate.back()
    sleep(2)
    @driver.find_element(:id, "back-btn").click
    assert(@driver.page_source.include?("VA Moms"), "The VA Moms text does not exist.")

    # Verify Pregnancy Resources link
    @driver.find_element(:partial_link_text, "Pregnancy Resources").click
    assert(@driver.page_source.include?("Pregnancy Resources"), "The Pregnancy Resources text does not exist.")
    @driver.find_element(:id, "back-btn").click

  end

  def element_present?(how, what)
    @driver.find_element(how, what)
    true
  rescue Selenium::WebDriver::Error::NoSuchElementError
    false
  end

  def alert_present?()
    @driver.switch_to.alert
    true
  rescue Selenium::WebDriver::Error::NoAlertPresentError
    false
  end

  def verify(&blk)
    yield
  rescue Test::Unit::AssertionFailedError => ex
    @verification_errors << ex
  end

  def close_alert_and_get_its_text(how, what)
    alert = @driver.switch_to().alert()
    alert_text = alert.text
    if (@accept_next_alert) then
      alert.accept()
    else
      alert.dismiss()
    end
    alert_text
  ensure
    @accept_next_alert = true
  end
end
