require_relative 'Functions'
require "json"
require "selenium-webdriver"
gem "test-unit"
require "test/unit"


class LaunchApp < Test::Unit::TestCase
  def setup
    @driver = Selenium::WebDriver.for :firefox
    @accept_next_alert = true
    @driver.manage.timeouts.implicit_wait = 30
    @verification_errors = []

    set_variables()

  end

  def teardown
    @driver.quit
    assert_equal [], @verification_errors

  end

  def test_Validation

    # MTS-39 Create Profile

    # Logging into VA Moms home page
    accept_eula()
    sleep(5)
    assert(@driver.page_source.include?("Any data entered in this app will be shared with"), "Additional confirmation page not dispalyed")
    sleep(5)
    @driver.find_element(:id, "accept-btn").click
    sleep(5)
    @driver.find_element(:id, "login").click
    sleep(5)
    @driver.find_element(:id, "name-c").clear
    @driver.find_element(:id, "name-c").send_keys "zztest.patient01"
    @driver.find_element(:id, "password").clear
    @driver.find_element(:id, "password").send_keys "pass"
    @driver.find_element(:id, "loginButton").click

    # Verify the name of app, intro text and login button are present in the main page
    assert(@driver.page_source.include?("VA Moms"), "App name not present on home page.")
    string_present = @driver.page_source.include?("Chart your pregnancy")
    #assert(string_present, "Info text is not present on home page")

    # Refresh page after deleting the profile record from database


    if (element_present?(:id, "create") ) then
      @driver.find_element(:id, "create").click
      @driver.find_element(:id, "nameFirst").clear
      @driver.find_element(:id, "nameFirst").send_keys "test11"
      sleep 1
      @driver.find_element(:id, "save-btn").click
      sleep 2
      assert(@driver.page_source.include?("Incomplete"), "Lastname required field check ")
      @driver.find_element(:id, "nameLast").clear
      @driver.find_element(:id, "nameLast").send_keys "Smith11"
      @driver.find_element(:id, "nameFirst").clear
      @driver.find_element(:id, "wbp").clear
      @driver.find_element(:id, "wbp").send_keys "610"
      @driver.find_element(:id, "save-btn").click
      assert(@driver.page_source.include?("Incomplete"), "Firstname required field check ")
      assert(@driver.page_source.include?("Please check the number and re-enter"), "WBP should be in the range of 50 -500 ")
      @driver.find_element(:id, "nameFirst").clear
      @driver.find_element(:id, "nameLast").clear
      @driver.find_element(:id, "wbp").clear
      @driver.find_element(:id, "currWgt").clear
      @driver.find_element(:id, "currWgt").send_keys "650"
      @driver.find_element(:id, "obProvider").clear
      @driver.find_element(:id, "obProvider").send_keys "Test2"
      assert(@driver.page_source.include?("The number entered is outside expected range"), "Curr weight should be in the range of 50 -500 ")
      @driver.find_element(:id, "mcc").clear
      @driver.find_element(:id, "mcc").send_keys "Phone1"
      @driver.find_element(:id, "mccContact").clear
      @driver.find_element(:id, "mccContact").send_keys "23434534we56"
      @driver.find_element(:id, "save-btn").click

      assert(@driver.page_source.include?("Please re-enter phone number"), "validation failed for numeric only check for maternity-phone-number ")
      #@driver.find_element(:id, "lmp").clear
      #@driver.find_element(:id, "lmp").send_keys "05/01/2014"
      #@driver.find_element(:id, "edd").clear
      #@driver.find_element(:id, "edd").send_keys "03/04/2017"
     # @driver.find_element(:id, "save-btn").click
     # assert(@driver.page_source.include?("The date entered is outside expected range"), "validation failed for  edd ")

    else
    sleep(10)
      verify {assert(@driver.find_element(:partial_link_text, "My Profile"), "Unable to find my profile link")}
      verify {assert(@driver.find_element(:partial_link_text, "My OB Care Journal"), "Unable to find obcare journal link")}
      verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Tracker"), "Unable to find Diagnosis link")}
      verify {assert(@driver.find_element(:partial_link_text, "My VA Medical Record"), "Unable to find VA Med record link")}
      verify {assert(@driver.find_element(:partial_link_text, "Pregnancy Resources"), "Unable to find pregnancy resources link")}
    @driver.find_element(:partial_link_text, "Pregnancy Tracker").click
    sleep(5)
    assert_equal("Pregnancy Tracker",@driver.find_element(:id, "pregnancy-tracker").text)
    verify {assert(@driver.find_element(:partial_link_text, "My Profile"), "Unable to find my profile link")}
    verify {assert(@driver.find_element(:partial_link_text, "Health Conditions"), "Unable to find Diagnosis link")}
    verify {assert(@driver.find_element(:partial_link_text, "Medications this Pregnancy"), "Unable to find Medications this Pregnancy link")}
    verify {assert(@driver.find_element(:partial_link_text, "Labs"), "Unable to find Labs link")}
    verify {assert(@driver.find_element(:partial_link_text, "Ultrasounds"), "Unable to find Ultrasounds link")}
    verify {assert(@driver.find_element(:partial_link_text, "Genetic Screening"), "Unable to find Genetic Screening link")}
    verify {assert(@driver.find_element(:partial_link_text, "Vaccination"), "Unable to find Vaccination link")}
    verify {assert(@driver.find_element(:partial_link_text, "Your Pregnancy Outcome"), "Unable to find Pregnancy Outcome link")}
    # Click on the myprofile button
    @driver.find_element(:partial_link_text, "My Profile").click
    sleep(5)

    @driver.find_element(:id, "nameFirst").clear
    @driver.find_element(:id, "nameFirst").send_keys "test11"
    @driver.find_element(:id, "nameLast").clear
    @driver.find_element(:id, "save-btn").click
    sleep(5)
    assert(@driver.page_source.include?("Incomplete"), "Lastname required field check ")
    @driver.find_element(:id, "nameLast").clear
    @driver.find_element(:id, "nameLast").send_keys "Smith11"
    @driver.find_element(:id, "nameFirst").clear
    @driver.find_element(:id, "wbp").clear
    @driver.find_element(:id, "wbp").send_keys "601"
    @driver.find_element(:id, "save-btn").click
    assert(@driver.page_source.include?("Incomplete"), "Firstname required field check ")
    sleep 5
    assert(@driver.page_source.include?("Please check the number and re-enter"), "WBP should be in the range of 50 -600 ")
    @driver.find_element(:id, "nameFirst").clear
    @driver.find_element(:id, "nameLast").clear
    @driver.find_element(:id, "wbp").clear
    @driver.find_element(:id, "currWgt").clear
    @driver.find_element(:id, "currWgt").send_keys "650"
    @driver.find_element(:id, "obProvider").clear
    @driver.find_element(:id, "obProvider").send_keys "Test2"
    sleep 5
    #assert(@driver.page_source.include?("The number entered is outside expected range"), "Curr weight should be in the range of 50 -500 ")
    @driver.find_element(:id, "mcc").clear
    @driver.find_element(:id, "mcc").send_keys "Phone1"
    @driver.find_element(:id, "mccContact").clear
    @driver.find_element(:id, "mccContact").send_keys "23434534we56"
    @driver.find_element(:id, "save-btn").click

    @driver.find_element(:id, "edd").clear
    @driver.find_element(:id, "edd").send_keys "03/04/2017"
    @driver.find_element(:id, "save-btn").click
end


  end

  def element_present?(how, what)
    @driver.find_element(how, what)
    true
  rescue Selenium::WebDriver::Error::NoSuchElementError
    false
  end

  def alert_present?()
    @driver.switch_to.alert
    true
  rescue Selenium::WebDriver::Error::NoAlertPresentError
    false
  end

  def verify(&blk)
    yield
  rescue Test::Unit::AssertionFailedError => ex
    @verification_errors << ex
  end

  def close_alert_and_get_its_text(how, what)
    alert = @driver.switch_to().alert()
    alert_text = alert.text
    if (@accept_next_alert) then
      alert.accept()
    else
      alert.dismiss()
    end
    alert_text
  ensure
    @accept_next_alert = true
  end
end
